<?php

namespace App\Library\ExactTarget;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'APIFault' => '\\App\\Library\\ExactTarget\\StructType\\APIFault',
            'Params' => '\\App\\Library\\ExactTarget\\StructType\\Params',
            'APIObject' => '\\App\\Library\\ExactTarget\\StructType\\APIObject',
            'ClientID' => '\\App\\Library\\ExactTarget\\StructType\\ClientID',
            'APIProperty' => '\\App\\Library\\ExactTarget\\StructType\\APIProperty',
            'NullAPIProperty' => '\\App\\Library\\ExactTarget\\StructType\\NullAPIProperty',
            'DataFolder' => '\\App\\Library\\ExactTarget\\StructType\\DataFolder',
            'Owner' => '\\App\\Library\\ExactTarget\\StructType\\Owner',
            'AsyncResponse' => '\\App\\Library\\ExactTarget\\StructType\\AsyncResponse',
            'ContainerID' => '\\App\\Library\\ExactTarget\\StructType\\ContainerID',
            'Request' => '\\App\\Library\\ExactTarget\\StructType\\Request',
            'Result' => '\\App\\Library\\ExactTarget\\StructType\\Result',
            'ResultMessage' => '\\App\\Library\\ExactTarget\\StructType\\ResultMessage',
            'ResultItem' => '\\App\\Library\\ExactTarget\\StructType\\ResultItem',
            'Options' => '\\App\\Library\\ExactTarget\\StructType\\Options',
            'SaveOptions' => '\\App\\Library\\ExactTarget\\StructType\\SaveOptions',
            'TaskResult' => '\\App\\Library\\ExactTarget\\StructType\\TaskResult',
            'SaveOption' => '\\App\\Library\\ExactTarget\\StructType\\SaveOption',
            'CreateRequest' => '\\App\\Library\\ExactTarget\\StructType\\CreateRequest',
            'CreateResult' => '\\App\\Library\\ExactTarget\\StructType\\CreateResult',
            'CreateResponse' => '\\App\\Library\\ExactTarget\\StructType\\CreateResponse',
            'CreateOptions' => '\\App\\Library\\ExactTarget\\StructType\\CreateOptions',
            'UpdateOptions' => '\\App\\Library\\ExactTarget\\StructType\\UpdateOptions',
            'UpdateRequest' => '\\App\\Library\\ExactTarget\\StructType\\UpdateRequest',
            'UpdateResult' => '\\App\\Library\\ExactTarget\\StructType\\UpdateResult',
            'UpdateResponse' => '\\App\\Library\\ExactTarget\\StructType\\UpdateResponse',
            'DeleteOptions' => '\\App\\Library\\ExactTarget\\StructType\\DeleteOptions',
            'DeleteRequest' => '\\App\\Library\\ExactTarget\\StructType\\DeleteRequest',
            'DeleteResult' => '\\App\\Library\\ExactTarget\\StructType\\DeleteResult',
            'DeleteResponse' => '\\App\\Library\\ExactTarget\\StructType\\DeleteResponse',
            'RetrieveRequest' => '\\App\\Library\\ExactTarget\\StructType\\RetrieveRequest',
            'Retrieves' => '\\App\\Library\\ExactTarget\\StructType\\Retrieves',
            'RetrieveRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\RetrieveRequestMsg',
            'RetrieveResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\RetrieveResponseMsg',
            'RetrieveSingleRequest' => '\\App\\Library\\ExactTarget\\StructType\\RetrieveSingleRequest',
            'Parameters' => '\\App\\Library\\ExactTarget\\StructType\\Parameters',
            'RetrieveSingleOptions' => '\\App\\Library\\ExactTarget\\StructType\\RetrieveSingleOptions',
            'RetrieveOptions' => '\\App\\Library\\ExactTarget\\StructType\\RetrieveOptions',
            'QueryRequest' => '\\App\\Library\\ExactTarget\\StructType\\QueryRequest',
            'QueryRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\QueryRequestMsg',
            'QueryResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\QueryResponseMsg',
            'QueryObject' => '\\App\\Library\\ExactTarget\\StructType\\QueryObject',
            'Query' => '\\App\\Library\\ExactTarget\\StructType\\Query',
            'FilterPart' => '\\App\\Library\\ExactTarget\\StructType\\FilterPart',
            'SimpleFilterPart' => '\\App\\Library\\ExactTarget\\StructType\\SimpleFilterPart',
            'TagFilterPart' => '\\App\\Library\\ExactTarget\\StructType\\TagFilterPart',
            'Tags' => '\\App\\Library\\ExactTarget\\StructType\\Tags',
            'ComplexFilterPart' => '\\App\\Library\\ExactTarget\\StructType\\ComplexFilterPart',
            'AdditionalOperands' => '\\App\\Library\\ExactTarget\\StructType\\AdditionalOperands',
            'DefinitionRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\DefinitionRequestMsg',
            'ArrayOfObjectDefinitionRequest' => '\\App\\Library\\ExactTarget\\ArrayType\\ArrayOfObjectDefinitionRequest',
            'ObjectDefinitionRequest' => '\\App\\Library\\ExactTarget\\StructType\\ObjectDefinitionRequest',
            'DefinitionResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\DefinitionResponseMsg',
            'PropertyDefinition' => '\\App\\Library\\ExactTarget\\StructType\\PropertyDefinition',
            'PicklistItems' => '\\App\\Library\\ExactTarget\\StructType\\PicklistItems',
            'References' => '\\App\\Library\\ExactTarget\\StructType\\References',
            'ObjectDefinition' => '\\App\\Library\\ExactTarget\\StructType\\ObjectDefinition',
            'ExtendedProperties' => '\\App\\Library\\ExactTarget\\StructType\\ExtendedProperties',
            'AttributeMap' => '\\App\\Library\\ExactTarget\\StructType\\AttributeMap',
            'PicklistItem' => '\\App\\Library\\ExactTarget\\StructType\\PicklistItem',
            'ExecuteRequest' => '\\App\\Library\\ExactTarget\\StructType\\ExecuteRequest',
            'ExecuteResponse' => '\\App\\Library\\ExactTarget\\StructType\\ExecuteResponse',
            'ExecuteRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\ExecuteRequestMsg',
            'ExecuteResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\ExecuteResponseMsg',
            'InteractionDefinition' => '\\App\\Library\\ExactTarget\\StructType\\InteractionDefinition',
            'InteractionBaseObject' => '\\App\\Library\\ExactTarget\\StructType\\InteractionBaseObject',
            'PerformOptions' => '\\App\\Library\\ExactTarget\\StructType\\PerformOptions',
            'CampaignPerformOptions' => '\\App\\Library\\ExactTarget\\StructType\\CampaignPerformOptions',
            'PerformRequest' => '\\App\\Library\\ExactTarget\\StructType\\PerformRequest',
            'Definitions' => '\\App\\Library\\ExactTarget\\StructType\\Definitions',
            'PerformResponse' => '\\App\\Library\\ExactTarget\\StructType\\PerformResponse',
            'Results' => '\\App\\Library\\ExactTarget\\StructType\\Results',
            'PerformResult' => '\\App\\Library\\ExactTarget\\StructType\\PerformResult',
            'PerformRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\PerformRequestMsg',
            'PerformResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\PerformResponseMsg',
            'ValidationAction' => '\\App\\Library\\ExactTarget\\StructType\\ValidationAction',
            'ValidationOptions' => '\\App\\Library\\ExactTarget\\StructType\\ValidationOptions',
            'SpamAssassinValidation' => '\\App\\Library\\ExactTarget\\StructType\\SpamAssassinValidation',
            'ContentValidation' => '\\App\\Library\\ExactTarget\\StructType\\ContentValidation',
            'Subscribers' => '\\App\\Library\\ExactTarget\\StructType\\Subscribers',
            'ContentValidationResult' => '\\App\\Library\\ExactTarget\\StructType\\ContentValidationResult',
            'ValidationResult' => '\\App\\Library\\ExactTarget\\StructType\\ValidationResult',
            'ContentValidationTaskResult' => '\\App\\Library\\ExactTarget\\StructType\\ContentValidationTaskResult',
            'ValidationResults' => '\\App\\Library\\ExactTarget\\StructType\\ValidationResults',
            'ConfigureOptions' => '\\App\\Library\\ExactTarget\\StructType\\ConfigureOptions',
            'ConfigureResult' => '\\App\\Library\\ExactTarget\\StructType\\ConfigureResult',
            'ConfigureRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\ConfigureRequestMsg',
            'Configurations' => '\\App\\Library\\ExactTarget\\StructType\\Configurations',
            'ConfigureResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\ConfigureResponseMsg',
            'ScheduleDefinition' => '\\App\\Library\\ExactTarget\\StructType\\ScheduleDefinition',
            'ScheduleOptions' => '\\App\\Library\\ExactTarget\\StructType\\ScheduleOptions',
            'ScheduleResponse' => '\\App\\Library\\ExactTarget\\StructType\\ScheduleResponse',
            'ScheduleResult' => '\\App\\Library\\ExactTarget\\StructType\\ScheduleResult',
            'ScheduleRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\ScheduleRequestMsg',
            'Interactions' => '\\App\\Library\\ExactTarget\\StructType\\Interactions',
            'ScheduleResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\ScheduleResponseMsg',
            'Recurrence' => '\\App\\Library\\ExactTarget\\StructType\\Recurrence',
            'MinutelyRecurrence' => '\\App\\Library\\ExactTarget\\StructType\\MinutelyRecurrence',
            'HourlyRecurrence' => '\\App\\Library\\ExactTarget\\StructType\\HourlyRecurrence',
            'DailyRecurrence' => '\\App\\Library\\ExactTarget\\StructType\\DailyRecurrence',
            'WeeklyRecurrence' => '\\App\\Library\\ExactTarget\\StructType\\WeeklyRecurrence',
            'MonthlyRecurrence' => '\\App\\Library\\ExactTarget\\StructType\\MonthlyRecurrence',
            'YearlyRecurrence' => '\\App\\Library\\ExactTarget\\StructType\\YearlyRecurrence',
            'ExtractRequest' => '\\App\\Library\\ExactTarget\\StructType\\ExtractRequest',
            'ExtractResult' => '\\App\\Library\\ExactTarget\\StructType\\ExtractResult',
            'ExtractRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\ExtractRequestMsg',
            'ExtractResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\ExtractResponseMsg',
            'ExtractOptions' => '\\App\\Library\\ExactTarget\\StructType\\ExtractOptions',
            'ExtractParameter' => '\\App\\Library\\ExactTarget\\StructType\\ExtractParameter',
            'ExtractTemplate' => '\\App\\Library\\ExactTarget\\StructType\\ExtractTemplate',
            'ExtractDescription' => '\\App\\Library\\ExactTarget\\StructType\\ExtractDescription',
            'ExtractDefinition' => '\\App\\Library\\ExactTarget\\StructType\\ExtractDefinition',
            'Values' => '\\App\\Library\\ExactTarget\\StructType\\Values',
            'ParameterDescription' => '\\App\\Library\\ExactTarget\\StructType\\ParameterDescription',
            'ExtractParameterDescription' => '\\App\\Library\\ExactTarget\\StructType\\ExtractParameterDescription',
            'VersionInfoResponse' => '\\App\\Library\\ExactTarget\\StructType\\VersionInfoResponse',
            'VersionInfoRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\VersionInfoRequestMsg',
            'VersionInfoResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\VersionInfoResponseMsg',
            'Locale' => '\\App\\Library\\ExactTarget\\StructType\\Locale',
            'TimeZone' => '\\App\\Library\\ExactTarget\\StructType\\TimeZone',
            'Account' => '\\App\\Library\\ExactTarget\\StructType\\Account',
            'Roles' => '\\App\\Library\\ExactTarget\\StructType\\Roles',
            'BusinessUnit' => '\\App\\Library\\ExactTarget\\StructType\\BusinessUnit',
            'LandingPage' => '\\App\\Library\\ExactTarget\\StructType\\LandingPage',
            'AccountDataItem' => '\\App\\Library\\ExactTarget\\StructType\\AccountDataItem',
            'Subscription' => '\\App\\Library\\ExactTarget\\StructType\\Subscription',
            'PrivateLabel' => '\\App\\Library\\ExactTarget\\StructType\\PrivateLabel',
            'AccountPrivateLabel' => '\\App\\Library\\ExactTarget\\StructType\\AccountPrivateLabel',
            'BusinessRule' => '\\App\\Library\\ExactTarget\\StructType\\BusinessRule',
            'AccountUser' => '\\App\\Library\\ExactTarget\\StructType\\AccountUser',
            'AssociatedBusinessUnits' => '\\App\\Library\\ExactTarget\\StructType\\AssociatedBusinessUnits',
            'SsoIdentities' => '\\App\\Library\\ExactTarget\\StructType\\SsoIdentities',
            'SsoIdentity' => '\\App\\Library\\ExactTarget\\StructType\\SsoIdentity',
            'UserAccess' => '\\App\\Library\\ExactTarget\\StructType\\UserAccess',
            'Brand' => '\\App\\Library\\ExactTarget\\StructType\\Brand',
            'BrandTag' => '\\App\\Library\\ExactTarget\\StructType\\BrandTag',
            'Role' => '\\App\\Library\\ExactTarget\\StructType\\Role',
            'PermissionSets' => '\\App\\Library\\ExactTarget\\StructType\\PermissionSets',
            'Permissions' => '\\App\\Library\\ExactTarget\\StructType\\Permissions',
            'PermissionSet' => '\\App\\Library\\ExactTarget\\StructType\\PermissionSet',
            'Permission' => '\\App\\Library\\ExactTarget\\StructType\\Permission',
            'Email' => '\\App\\Library\\ExactTarget\\StructType\\Email',
            'ContentArea' => '\\App\\Library\\ExactTarget\\StructType\\ContentArea',
            'Message' => '\\App\\Library\\ExactTarget\\StructType\\Message',
            'TrackingEvent' => '\\App\\Library\\ExactTarget\\StructType\\TrackingEvent',
            'OpenEvent' => '\\App\\Library\\ExactTarget\\StructType\\OpenEvent',
            'BounceEvent' => '\\App\\Library\\ExactTarget\\StructType\\BounceEvent',
            'UnsubEvent' => '\\App\\Library\\ExactTarget\\StructType\\UnsubEvent',
            'ClickEvent' => '\\App\\Library\\ExactTarget\\StructType\\ClickEvent',
            'SentEvent' => '\\App\\Library\\ExactTarget\\StructType\\SentEvent',
            'NotSentEvent' => '\\App\\Library\\ExactTarget\\StructType\\NotSentEvent',
            'SurveyEvent' => '\\App\\Library\\ExactTarget\\StructType\\SurveyEvent',
            'ForwardedEmailEvent' => '\\App\\Library\\ExactTarget\\StructType\\ForwardedEmailEvent',
            'ForwardedEmailOptInEvent' => '\\App\\Library\\ExactTarget\\StructType\\ForwardedEmailOptInEvent',
            'DeliveredEvent' => '\\App\\Library\\ExactTarget\\StructType\\DeliveredEvent',
            'Subscriber' => '\\App\\Library\\ExactTarget\\StructType\\Subscriber',
            'Addresses' => '\\App\\Library\\ExactTarget\\StructType\\Addresses',
            'Attribute' => '\\App\\Library\\ExactTarget\\StructType\\Attribute',
            'CompressionConfiguration' => '\\App\\Library\\ExactTarget\\StructType\\CompressionConfiguration',
            'SubscriberTypeDefinition' => '\\App\\Library\\ExactTarget\\StructType\\SubscriberTypeDefinition',
            'ListSubscriber' => '\\App\\Library\\ExactTarget\\StructType\\ListSubscriber',
            'SubscriberList' => '\\App\\Library\\ExactTarget\\StructType\\SubscriberList',
            'List' => '\\App\\Library\\ExactTarget\\StructType\\_List',
            'Group' => '\\App\\Library\\ExactTarget\\StructType\\Group',
            'ListAttribute' => '\\App\\Library\\ExactTarget\\StructType\\ListAttribute',
            'ListAttributeRestrictedValue' => '\\App\\Library\\ExactTarget\\StructType\\ListAttributeRestrictedValue',
            'GlobalUnsubscribeCategory' => '\\App\\Library\\ExactTarget\\StructType\\GlobalUnsubscribeCategory',
            'Campaign' => '\\App\\Library\\ExactTarget\\StructType\\Campaign',
            'Send' => '\\App\\Library\\ExactTarget\\StructType\\Send',
            'Sources' => '\\App\\Library\\ExactTarget\\StructType\\Sources',
            'SuppressionLists' => '\\App\\Library\\ExactTarget\\StructType\\SuppressionLists',
            'Link' => '\\App\\Library\\ExactTarget\\StructType\\Link',
            'SendSummary' => '\\App\\Library\\ExactTarget\\StructType\\SendSummary',
            'TriggeredSendDefinition' => '\\App\\Library\\ExactTarget\\StructType\\TriggeredSendDefinition',
            'TriggeredSendExclusionList' => '\\App\\Library\\ExactTarget\\StructType\\TriggeredSendExclusionList',
            'TriggeredSend' => '\\App\\Library\\ExactTarget\\StructType\\TriggeredSend',
            'TriggeredSendCreateResult' => '\\App\\Library\\ExactTarget\\StructType\\TriggeredSendCreateResult',
            'SubscriberResult' => '\\App\\Library\\ExactTarget\\StructType\\SubscriberResult',
            'SubscriberSendResult' => '\\App\\Library\\ExactTarget\\StructType\\SubscriberSendResult',
            'TriggeredSendSummary' => '\\App\\Library\\ExactTarget\\StructType\\TriggeredSendSummary',
            'AsyncRequestResult' => '\\App\\Library\\ExactTarget\\StructType\\AsyncRequestResult',
            'VoiceTriggeredSend' => '\\App\\Library\\ExactTarget\\StructType\\VoiceTriggeredSend',
            'VoiceTriggeredSendDefinition' => '\\App\\Library\\ExactTarget\\StructType\\VoiceTriggeredSendDefinition',
            'SMSTriggeredSend' => '\\App\\Library\\ExactTarget\\StructType\\SMSTriggeredSend',
            'SMSTriggeredSendDefinition' => '\\App\\Library\\ExactTarget\\StructType\\SMSTriggeredSendDefinition',
            'SendClassification' => '\\App\\Library\\ExactTarget\\StructType\\SendClassification',
            'SenderProfile' => '\\App\\Library\\ExactTarget\\StructType\\SenderProfile',
            'DeliveryProfile' => '\\App\\Library\\ExactTarget\\StructType\\DeliveryProfile',
            'PrivateDomain' => '\\App\\Library\\ExactTarget\\StructType\\PrivateDomain',
            'PrivateDomainSet' => '\\App\\Library\\ExactTarget\\StructType\\PrivateDomainSet',
            'PrivateIP' => '\\App\\Library\\ExactTarget\\StructType\\PrivateIP',
            'SendDefinition' => '\\App\\Library\\ExactTarget\\StructType\\SendDefinition',
            'AudienceItem' => '\\App\\Library\\ExactTarget\\StructType\\AudienceItem',
            'EmailSendDefinition' => '\\App\\Library\\ExactTarget\\StructType\\EmailSendDefinition',
            'TrackingUsers' => '\\App\\Library\\ExactTarget\\StructType\\TrackingUsers',
            'DeprecatedEmailSendDefinition' => '\\App\\Library\\ExactTarget\\StructType\\DeprecatedEmailSendDefinition',
            'SendDefinitionList' => '\\App\\Library\\ExactTarget\\StructType\\SendDefinitionList',
            'TrackingUser' => '\\App\\Library\\ExactTarget\\StructType\\TrackingUser',
            'MessagingVendorKind' => '\\App\\Library\\ExactTarget\\StructType\\MessagingVendorKind',
            'MessagingConfiguration' => '\\App\\Library\\ExactTarget\\StructType\\MessagingConfiguration',
            'SMSMTEvent' => '\\App\\Library\\ExactTarget\\StructType\\SMSMTEvent',
            'SMSMOEvent' => '\\App\\Library\\ExactTarget\\StructType\\SMSMOEvent',
            'BaseMOKeyword' => '\\App\\Library\\ExactTarget\\StructType\\BaseMOKeyword',
            'SendSMSMOKeyword' => '\\App\\Library\\ExactTarget\\StructType\\SendSMSMOKeyword',
            'UnsubscribeFromSMSPublicationMOKeyword' => '\\App\\Library\\ExactTarget\\StructType\\UnsubscribeFromSMSPublicationMOKeyword',
            'DoubleOptInMOKeyword' => '\\App\\Library\\ExactTarget\\StructType\\DoubleOptInMOKeyword',
            'ValidPublications' => '\\App\\Library\\ExactTarget\\StructType\\ValidPublications',
            'ValidResponses' => '\\App\\Library\\ExactTarget\\StructType\\ValidResponses',
            'HelpMOKeyword' => '\\App\\Library\\ExactTarget\\StructType\\HelpMOKeyword',
            'SendEmailMOKeyword' => '\\App\\Library\\ExactTarget\\StructType\\SendEmailMOKeyword',
            'SMSSharedKeyword' => '\\App\\Library\\ExactTarget\\StructType\\SMSSharedKeyword',
            'UserMap' => '\\App\\Library\\ExactTarget\\StructType\\UserMap',
            'Folder' => '\\App\\Library\\ExactTarget\\StructType\\Folder',
            'SalesforceSendActivity' => '\\App\\Library\\ExactTarget\\StructType\\SalesforceSendActivity',
            'FileTransferLocation' => '\\App\\Library\\ExactTarget\\StructType\\FileTransferLocation',
            'DataExtractActivity' => '\\App\\Library\\ExactTarget\\StructType\\DataExtractActivity',
            'MessageSendActivity' => '\\App\\Library\\ExactTarget\\StructType\\MessageSendActivity',
            'SmsSendActivity' => '\\App\\Library\\ExactTarget\\StructType\\SmsSendActivity',
            'MobileConnectRefreshListActivity' => '\\App\\Library\\ExactTarget\\StructType\\MobileConnectRefreshListActivity',
            'MobileConnectSendSmsActivity' => '\\App\\Library\\ExactTarget\\StructType\\MobileConnectSendSmsActivity',
            'MobilePushSendMessageActivity' => '\\App\\Library\\ExactTarget\\StructType\\MobilePushSendMessageActivity',
            'ReportActivity' => '\\App\\Library\\ExactTarget\\StructType\\ReportActivity',
            'DataExtension' => '\\App\\Library\\ExactTarget\\StructType\\DataExtension',
            'Fields' => '\\App\\Library\\ExactTarget\\StructType\\Fields',
            'DataExtensionField' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionField',
            'DataExtensionTemplate' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionTemplate',
            'DataExtensionObject' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionObject',
            'Keys' => '\\App\\Library\\ExactTarget\\StructType\\Keys',
            'DataExtensionError' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionError',
            'DataExtensionCreateResult' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionCreateResult',
            'KeyErrors' => '\\App\\Library\\ExactTarget\\StructType\\KeyErrors',
            'ValueErrors' => '\\App\\Library\\ExactTarget\\StructType\\ValueErrors',
            'DataExtensionUpdateResult' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionUpdateResult',
            'DataExtensionDeleteResult' => '\\App\\Library\\ExactTarget\\StructType\\DataExtensionDeleteResult',
            'ImportDefinitionColumnBasedAction' => '\\App\\Library\\ExactTarget\\StructType\\ImportDefinitionColumnBasedAction',
            'FieldMap' => '\\App\\Library\\ExactTarget\\StructType\\FieldMap',
            'ImportDefinitionAutoGenerateDestination' => '\\App\\Library\\ExactTarget\\StructType\\ImportDefinitionAutoGenerateDestination',
            'ImportDefinition' => '\\App\\Library\\ExactTarget\\StructType\\ImportDefinition',
            'FieldMaps' => '\\App\\Library\\ExactTarget\\StructType\\FieldMaps',
            'ControlColumnActions' => '\\App\\Library\\ExactTarget\\StructType\\ControlColumnActions',
            'ImportDefinitionFieldMap' => '\\App\\Library\\ExactTarget\\StructType\\ImportDefinitionFieldMap',
            'ImportResultsSummary' => '\\App\\Library\\ExactTarget\\StructType\\ImportResultsSummary',
            'FilterActivity' => '\\App\\Library\\ExactTarget\\StructType\\FilterActivity',
            'FilterDefinition' => '\\App\\Library\\ExactTarget\\StructType\\FilterDefinition',
            'GroupDefinition' => '\\App\\Library\\ExactTarget\\StructType\\GroupDefinition',
            'GroupConnectActivity' => '\\App\\Library\\ExactTarget\\StructType\\GroupConnectActivity',
            'FileTransferActivity' => '\\App\\Library\\ExactTarget\\StructType\\FileTransferActivity',
            'ListSend' => '\\App\\Library\\ExactTarget\\StructType\\ListSend',
            'LinkSend' => '\\App\\Library\\ExactTarget\\StructType\\LinkSend',
            'ObjectExtension' => '\\App\\Library\\ExactTarget\\StructType\\ObjectExtension',
            'Properties' => '\\App\\Library\\ExactTarget\\StructType\\Properties',
            'PublicKeyManagement' => '\\App\\Library\\ExactTarget\\StructType\\PublicKeyManagement',
            'SecurityObject' => '\\App\\Library\\ExactTarget\\StructType\\SecurityObject',
            'Certificate' => '\\App\\Library\\ExactTarget\\StructType\\Certificate',
            'SystemStatusOptions' => '\\App\\Library\\ExactTarget\\StructType\\SystemStatusOptions',
            'SystemStatusRequestMsg' => '\\App\\Library\\ExactTarget\\StructType\\SystemStatusRequestMsg',
            'SystemStatusResult' => '\\App\\Library\\ExactTarget\\StructType\\SystemStatusResult',
            'Outages' => '\\App\\Library\\ExactTarget\\StructType\\Outages',
            'SystemStatusResponseMsg' => '\\App\\Library\\ExactTarget\\StructType\\SystemStatusResponseMsg',
            'SystemOutage' => '\\App\\Library\\ExactTarget\\StructType\\SystemOutage',
            'Authentication' => '\\App\\Library\\ExactTarget\\StructType\\Authentication',
            'UsernameAuthentication' => '\\App\\Library\\ExactTarget\\StructType\\UsernameAuthentication',
            'ResourceSpecification' => '\\App\\Library\\ExactTarget\\StructType\\ResourceSpecification',
            'Portfolio' => '\\App\\Library\\ExactTarget\\StructType\\Portfolio',
            'Template' => '\\App\\Library\\ExactTarget\\StructType\\Template',
            'Layout' => '\\App\\Library\\ExactTarget\\StructType\\Layout',
            'QueryDefinition' => '\\App\\Library\\ExactTarget\\StructType\\QueryDefinition',
            'HiveQueryDefinition' => '\\App\\Library\\ExactTarget\\StructType\\HiveQueryDefinition',
            'JsonWebKey' => '\\App\\Library\\ExactTarget\\StructType\\JsonWebKey',
            'DirectoryTenant' => '\\App\\Library\\ExactTarget\\StructType\\DirectoryTenant',
            'AuditLogUserContext' => '\\App\\Library\\ExactTarget\\StructType\\AuditLogUserContext',
            'IntegrationProfile' => '\\App\\Library\\ExactTarget\\StructType\\IntegrationProfile',
            'IntegrationProfileDefinition' => '\\App\\Library\\ExactTarget\\StructType\\IntegrationProfileDefinition',
            'ReplyMailManagementConfiguration' => '\\App\\Library\\ExactTarget\\StructType\\ReplyMailManagementConfiguration',
            'FileTrigger' => '\\App\\Library\\ExactTarget\\StructType\\FileTrigger',
            'FileTriggerTypeLastPull' => '\\App\\Library\\ExactTarget\\StructType\\FileTriggerTypeLastPull',
            'ProgramManifestTemplate' => '\\App\\Library\\ExactTarget\\StructType\\ProgramManifestTemplate',
            'SubscriberAddress' => '\\App\\Library\\ExactTarget\\StructType\\SubscriberAddress',
            'Statuses' => '\\App\\Library\\ExactTarget\\StructType\\Statuses',
            'SMSAddress' => '\\App\\Library\\ExactTarget\\StructType\\SMSAddress',
            'EmailAddress' => '\\App\\Library\\ExactTarget\\StructType\\EmailAddress',
            'AddressStatus' => '\\App\\Library\\ExactTarget\\StructType\\AddressStatus',
            'Publication' => '\\App\\Library\\ExactTarget\\StructType\\Publication',
            'PublicationSubscriber' => '\\App\\Library\\ExactTarget\\StructType\\PublicationSubscriber',
            'Automation' => '\\App\\Library\\ExactTarget\\StructType\\Automation',
            'AutomationTasks' => '\\App\\Library\\ExactTarget\\StructType\\AutomationTasks',
            'Notifications' => '\\App\\Library\\ExactTarget\\StructType\\Notifications',
            'AutomationSource' => '\\App\\Library\\ExactTarget\\StructType\\AutomationSource',
            'AutomationInstances' => '\\App\\Library\\ExactTarget\\StructType\\AutomationInstances',
            'AutomationInstanceCollection' => '\\App\\Library\\ExactTarget\\StructType\\AutomationInstanceCollection',
            'AutomationInstance' => '\\App\\Library\\ExactTarget\\StructType\\AutomationInstance',
            'TaskInstances' => '\\App\\Library\\ExactTarget\\StructType\\TaskInstances',
            'AutomationNotification' => '\\App\\Library\\ExactTarget\\StructType\\AutomationNotification',
            'AutomationTask' => '\\App\\Library\\ExactTarget\\StructType\\AutomationTask',
            'Activities' => '\\App\\Library\\ExactTarget\\StructType\\Activities',
            'AutomationTaskInstance' => '\\App\\Library\\ExactTarget\\StructType\\AutomationTaskInstance',
            'ActivityInstances' => '\\App\\Library\\ExactTarget\\StructType\\ActivityInstances',
            'AutomationActivity' => '\\App\\Library\\ExactTarget\\StructType\\AutomationActivity',
            'AutomationActivityInstance' => '\\App\\Library\\ExactTarget\\StructType\\AutomationActivityInstance',
            'AutomationChain' => '\\App\\Library\\ExactTarget\\StructType\\AutomationChain',
            'PlatformApplication' => '\\App\\Library\\ExactTarget\\StructType\\PlatformApplication',
            'PlatformApplicationPackage' => '\\App\\Library\\ExactTarget\\StructType\\PlatformApplicationPackage',
            'SuppressionListDefinition' => '\\App\\Library\\ExactTarget\\StructType\\SuppressionListDefinition',
            'Contexts' => '\\App\\Library\\ExactTarget\\StructType\\Contexts',
            'SuppressionListContext' => '\\App\\Library\\ExactTarget\\StructType\\SuppressionListContext',
            'SuppressionListData' => '\\App\\Library\\ExactTarget\\StructType\\SuppressionListData',
            'SendAdditionalAttribute' => '\\App\\Library\\ExactTarget\\StructType\\SendAdditionalAttribute',
            'ImportFileDestination' => '\\App\\Library\\ExactTarget\\StructType\\ImportFileDestination',
            'ContactEvent' => '\\App\\Library\\ExactTarget\\StructType\\ContactEvent',
            'Data' => '\\App\\Library\\ExactTarget\\StructType\\Data',
            'AttributeSet' => '\\App\\Library\\ExactTarget\\StructType\\AttributeSet',
            'Items' => '\\App\\Library\\ExactTarget\\StructType\\Items',
            'AttributeValueContainer' => '\\App\\Library\\ExactTarget\\StructType\\AttributeValueContainer',
            'AttributeValue' => '\\App\\Library\\ExactTarget\\StructType\\AttributeValue',
            'ContactEventCreateResult' => '\\App\\Library\\ExactTarget\\StructType\\ContactEventCreateResult',
        );
    }
}
