<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AuditLogUserContext StructType
 * @subpackage Structs
 */
class AuditLogUserContext extends AbstractStructBase
{
    /**
     * The InitiatingUserName
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InitiatingUserName;
    /**
     * The InitiatingUserIpAddress
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InitiatingUserIpAddress;
    /**
     * Constructor method for AuditLogUserContext
     * @uses AuditLogUserContext::setInitiatingUserName()
     * @uses AuditLogUserContext::setInitiatingUserIpAddress()
     * @param string $initiatingUserName
     * @param string $initiatingUserIpAddress
     */
    public function __construct($initiatingUserName = null, $initiatingUserIpAddress = null)
    {
        $this
            ->setInitiatingUserName($initiatingUserName)
            ->setInitiatingUserIpAddress($initiatingUserIpAddress);
    }
    /**
     * Get InitiatingUserName value
     * @return string|null
     */
    public function getInitiatingUserName()
    {
        return $this->InitiatingUserName;
    }
    /**
     * Set InitiatingUserName value
     * @param string $initiatingUserName
     * @return \App\Library\ExactTarget\StructType\AuditLogUserContext
     */
    public function setInitiatingUserName($initiatingUserName = null)
    {
        // validation for constraint: string
        if (!is_null($initiatingUserName) && !is_string($initiatingUserName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($initiatingUserName)), __LINE__);
        }
        $this->InitiatingUserName = $initiatingUserName;
        return $this;
    }
    /**
     * Get InitiatingUserIpAddress value
     * @return string|null
     */
    public function getInitiatingUserIpAddress()
    {
        return $this->InitiatingUserIpAddress;
    }
    /**
     * Set InitiatingUserIpAddress value
     * @param string $initiatingUserIpAddress
     * @return \App\Library\ExactTarget\StructType\AuditLogUserContext
     */
    public function setInitiatingUserIpAddress($initiatingUserIpAddress = null)
    {
        // validation for constraint: string
        if (!is_null($initiatingUserIpAddress) && !is_string($initiatingUserIpAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($initiatingUserIpAddress)), __LINE__);
        }
        $this->InitiatingUserIpAddress = $initiatingUserIpAddress;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\AuditLogUserContext
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
