<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AutomationTaskInstance StructType
 * @subpackage Structs
 */
class AutomationTaskInstance extends AutomationTask
{
    /**
     * The StepDefinition
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\AutomationTask
     */
    public $StepDefinition;
    /**
     * The AutomationInstance
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\AutomationInstance
     */
    public $AutomationInstance;
    /**
     * The ActivityInstances
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ActivityInstances
     */
    public $ActivityInstances;
    /**
     * Constructor method for AutomationTaskInstance
     * @uses AutomationTaskInstance::setStepDefinition()
     * @uses AutomationTaskInstance::setAutomationInstance()
     * @uses AutomationTaskInstance::setActivityInstances()
     * @param \App\Library\ExactTarget\StructType\AutomationTask $stepDefinition
     * @param \App\Library\ExactTarget\StructType\AutomationInstance $automationInstance
     * @param \App\Library\ExactTarget\StructType\ActivityInstances $activityInstances
     */
    public function __construct(\App\Library\ExactTarget\StructType\AutomationTask $stepDefinition = null, \App\Library\ExactTarget\StructType\AutomationInstance $automationInstance = null, \App\Library\ExactTarget\StructType\ActivityInstances $activityInstances = null)
    {
        $this
            ->setStepDefinition($stepDefinition)
            ->setAutomationInstance($automationInstance)
            ->setActivityInstances($activityInstances);
    }
    /**
     * Get StepDefinition value
     * @return \App\Library\ExactTarget\StructType\AutomationTask|null
     */
    public function getStepDefinition()
    {
        return $this->StepDefinition;
    }
    /**
     * Set StepDefinition value
     * @param \App\Library\ExactTarget\StructType\AutomationTask $stepDefinition
     * @return \App\Library\ExactTarget\StructType\AutomationTaskInstance
     */
    public function setStepDefinition(\App\Library\ExactTarget\StructType\AutomationTask $stepDefinition = null)
    {
        $this->StepDefinition = $stepDefinition;
        return $this;
    }
    /**
     * Get AutomationInstance value
     * @return \App\Library\ExactTarget\StructType\AutomationInstance|null
     */
    public function getAutomationInstance()
    {
        return $this->AutomationInstance;
    }
    /**
     * Set AutomationInstance value
     * @param \App\Library\ExactTarget\StructType\AutomationInstance $automationInstance
     * @return \App\Library\ExactTarget\StructType\AutomationTaskInstance
     */
    public function setAutomationInstance(\App\Library\ExactTarget\StructType\AutomationInstance $automationInstance = null)
    {
        $this->AutomationInstance = $automationInstance;
        return $this;
    }
    /**
     * Get ActivityInstances value
     * @return \App\Library\ExactTarget\StructType\ActivityInstances|null
     */
    public function getActivityInstances()
    {
        return $this->ActivityInstances;
    }
    /**
     * Set ActivityInstances value
     * @param \App\Library\ExactTarget\StructType\ActivityInstances $activityInstances
     * @return \App\Library\ExactTarget\StructType\AutomationTaskInstance
     */
    public function setActivityInstances(\App\Library\ExactTarget\StructType\ActivityInstances $activityInstances = null)
    {
        $this->ActivityInstances = $activityInstances;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\AutomationTaskInstance
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
