<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConfigureRequestMsg StructType
 * @subpackage Structs
 */
class ConfigureRequestMsg extends AbstractStructBase
{
    /**
     * The Options
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ConfigureOptions
     */
    public $Options;
    /**
     * The Action
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Action;
    /**
     * The Configurations
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Configurations
     */
    public $Configurations;
    /**
     * Constructor method for ConfigureRequestMsg
     * @uses ConfigureRequestMsg::setOptions()
     * @uses ConfigureRequestMsg::setAction()
     * @uses ConfigureRequestMsg::setConfigurations()
     * @param \App\Library\ExactTarget\StructType\ConfigureOptions $options
     * @param string $action
     * @param \App\Library\ExactTarget\StructType\Configurations $configurations
     */
    public function __construct(\App\Library\ExactTarget\StructType\ConfigureOptions $options = null, $action = null, \App\Library\ExactTarget\StructType\Configurations $configurations = null)
    {
        $this
            ->setOptions($options)
            ->setAction($action)
            ->setConfigurations($configurations);
    }
    /**
     * Get Options value
     * @return \App\Library\ExactTarget\StructType\ConfigureOptions|null
     */
    public function getOptions()
    {
        return $this->Options;
    }
    /**
     * Set Options value
     * @param \App\Library\ExactTarget\StructType\ConfigureOptions $options
     * @return \App\Library\ExactTarget\StructType\ConfigureRequestMsg
     */
    public function setOptions(\App\Library\ExactTarget\StructType\ConfigureOptions $options = null)
    {
        $this->Options = $options;
        return $this;
    }
    /**
     * Get Action value
     * @return string|null
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @param string $action
     * @return \App\Library\ExactTarget\StructType\ConfigureRequestMsg
     */
    public function setAction($action = null)
    {
        // validation for constraint: string
        if (!is_null($action) && !is_string($action)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($action)), __LINE__);
        }
        $this->Action = $action;
        return $this;
    }
    /**
     * Get Configurations value
     * @return \App\Library\ExactTarget\StructType\Configurations|null
     */
    public function getConfigurations()
    {
        return $this->Configurations;
    }
    /**
     * Set Configurations value
     * @param \App\Library\ExactTarget\StructType\Configurations $configurations
     * @return \App\Library\ExactTarget\StructType\ConfigureRequestMsg
     */
    public function setConfigurations(\App\Library\ExactTarget\StructType\Configurations $configurations = null)
    {
        $this->Configurations = $configurations;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ConfigureRequestMsg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
