<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ContentValidation StructType
 * Meta informations extracted from the WSDL
 * - type: tns:ContentValidation
 * @subpackage Structs
 */
class ContentValidation extends APIObject
{
    /**
     * The ValidationAction
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ValidationAction
     */
    public $ValidationAction;
    /**
     * The Email
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Email
     */
    public $Email;
    /**
     * The Subscribers
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Subscribers
     */
    public $Subscribers;
    /**
     * Constructor method for ContentValidation
     * @uses ContentValidation::setValidationAction()
     * @uses ContentValidation::setEmail()
     * @uses ContentValidation::setSubscribers()
     * @param \App\Library\ExactTarget\StructType\ValidationAction $validationAction
     * @param \App\Library\ExactTarget\StructType\Email $email
     * @param \App\Library\ExactTarget\StructType\Subscribers $subscribers
     */
    public function __construct(\App\Library\ExactTarget\StructType\ValidationAction $validationAction = null, \App\Library\ExactTarget\StructType\Email $email = null, \App\Library\ExactTarget\StructType\Subscribers $subscribers = null)
    {
        $this
            ->setValidationAction($validationAction)
            ->setEmail($email)
            ->setSubscribers($subscribers);
    }
    /**
     * Get ValidationAction value
     * @return \App\Library\ExactTarget\StructType\ValidationAction|null
     */
    public function getValidationAction()
    {
        return $this->ValidationAction;
    }
    /**
     * Set ValidationAction value
     * @param \App\Library\ExactTarget\StructType\ValidationAction $validationAction
     * @return \App\Library\ExactTarget\StructType\ContentValidation
     */
    public function setValidationAction(\App\Library\ExactTarget\StructType\ValidationAction $validationAction = null)
    {
        $this->ValidationAction = $validationAction;
        return $this;
    }
    /**
     * Get Email value
     * @return \App\Library\ExactTarget\StructType\Email|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param \App\Library\ExactTarget\StructType\Email $email
     * @return \App\Library\ExactTarget\StructType\ContentValidation
     */
    public function setEmail(\App\Library\ExactTarget\StructType\Email $email = null)
    {
        $this->Email = $email;
        return $this;
    }
    /**
     * Get Subscribers value
     * @return \App\Library\ExactTarget\StructType\Subscribers|null
     */
    public function getSubscribers()
    {
        return $this->Subscribers;
    }
    /**
     * Set Subscribers value
     * @param \App\Library\ExactTarget\StructType\Subscribers $subscribers
     * @return \App\Library\ExactTarget\StructType\ContentValidation
     */
    public function setSubscribers(\App\Library\ExactTarget\StructType\Subscribers $subscribers = null)
    {
        $this->Subscribers = $subscribers;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ContentValidation
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
