<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ControlColumnActions StructType
 * @subpackage Structs
 */
class ControlColumnActions extends AbstractStructBase
{
    /**
     * The ControlColumnAction
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction[]
     */
    public $ControlColumnAction;
    /**
     * Constructor method for ControlColumnActions
     * @uses ControlColumnActions::setControlColumnAction()
     * @param \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction[] $controlColumnAction
     */
    public function __construct(array $controlColumnAction = array())
    {
        $this
            ->setControlColumnAction($controlColumnAction);
    }
    /**
     * Get ControlColumnAction value
     * @return \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction[]|null
     */
    public function getControlColumnAction()
    {
        return $this->ControlColumnAction;
    }
    /**
     * Set ControlColumnAction value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction[] $controlColumnAction
     * @return \App\Library\ExactTarget\StructType\ControlColumnActions
     */
    public function setControlColumnAction(array $controlColumnAction = array())
    {
        foreach ($controlColumnAction as $controlColumnActionsControlColumnActionItem) {
            // validation for constraint: itemType
            if (!$controlColumnActionsControlColumnActionItem instanceof \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction) {
                throw new \InvalidArgumentException(sprintf('The ControlColumnAction property can only contain items of \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction, "%s" given', is_object($controlColumnActionsControlColumnActionItem) ? get_class($controlColumnActionsControlColumnActionItem) : gettype($controlColumnActionsControlColumnActionItem)), __LINE__);
            }
        }
        $this->ControlColumnAction = $controlColumnAction;
        return $this;
    }
    /**
     * Add item to ControlColumnAction value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction $item
     * @return \App\Library\ExactTarget\StructType\ControlColumnActions
     */
    public function addToControlColumnAction(\App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction) {
            throw new \InvalidArgumentException(sprintf('The ControlColumnAction property can only contain items of \App\Library\ExactTarget\StructType\ImportDefinitionColumnBasedAction, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ControlColumnAction[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ControlColumnActions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
