<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DoubleOptInMOKeyword StructType
 * @subpackage Structs
 */
class DoubleOptInMOKeyword extends BaseMOKeyword
{
    /**
     * The DefaultPublication
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\_List
     */
    public $DefaultPublication;
    /**
     * The InvalidPublicationMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InvalidPublicationMessage;
    /**
     * The InvalidResponseMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InvalidResponseMessage;
    /**
     * The MissingPublicationMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $MissingPublicationMessage;
    /**
     * The NeedPublicationMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $NeedPublicationMessage;
    /**
     * The PromptMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $PromptMessage;
    /**
     * The SuccessMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SuccessMessage;
    /**
     * The UnexpectedErrorMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $UnexpectedErrorMessage;
    /**
     * The ValidPublications
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\ValidPublications
     */
    public $ValidPublications;
    /**
     * The ValidResponses
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\ValidResponses
     */
    public $ValidResponses;
    /**
     * Constructor method for DoubleOptInMOKeyword
     * @uses DoubleOptInMOKeyword::setDefaultPublication()
     * @uses DoubleOptInMOKeyword::setInvalidPublicationMessage()
     * @uses DoubleOptInMOKeyword::setInvalidResponseMessage()
     * @uses DoubleOptInMOKeyword::setMissingPublicationMessage()
     * @uses DoubleOptInMOKeyword::setNeedPublicationMessage()
     * @uses DoubleOptInMOKeyword::setPromptMessage()
     * @uses DoubleOptInMOKeyword::setSuccessMessage()
     * @uses DoubleOptInMOKeyword::setUnexpectedErrorMessage()
     * @uses DoubleOptInMOKeyword::setValidPublications()
     * @uses DoubleOptInMOKeyword::setValidResponses()
     * @param \App\Library\ExactTarget\StructType\_List $defaultPublication
     * @param string $invalidPublicationMessage
     * @param string $invalidResponseMessage
     * @param string $missingPublicationMessage
     * @param string $needPublicationMessage
     * @param string $promptMessage
     * @param string $successMessage
     * @param string $unexpectedErrorMessage
     * @param \App\Library\ExactTarget\StructType\ValidPublications $validPublications
     * @param \App\Library\ExactTarget\StructType\ValidResponses $validResponses
     */
    public function __construct(\App\Library\ExactTarget\StructType\_List $defaultPublication = null, $invalidPublicationMessage = null, $invalidResponseMessage = null, $missingPublicationMessage = null, $needPublicationMessage = null, $promptMessage = null, $successMessage = null, $unexpectedErrorMessage = null, \App\Library\ExactTarget\StructType\ValidPublications $validPublications = null, \App\Library\ExactTarget\StructType\ValidResponses $validResponses = null)
    {
        $this
            ->setDefaultPublication($defaultPublication)
            ->setInvalidPublicationMessage($invalidPublicationMessage)
            ->setInvalidResponseMessage($invalidResponseMessage)
            ->setMissingPublicationMessage($missingPublicationMessage)
            ->setNeedPublicationMessage($needPublicationMessage)
            ->setPromptMessage($promptMessage)
            ->setSuccessMessage($successMessage)
            ->setUnexpectedErrorMessage($unexpectedErrorMessage)
            ->setValidPublications($validPublications)
            ->setValidResponses($validResponses);
    }
    /**
     * Get DefaultPublication value
     * @return \App\Library\ExactTarget\StructType\_List
     */
    public function getDefaultPublication()
    {
        return $this->DefaultPublication;
    }
    /**
     * Set DefaultPublication value
     * @param \App\Library\ExactTarget\StructType\_List $defaultPublication
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setDefaultPublication(\App\Library\ExactTarget\StructType\_List $defaultPublication = null)
    {
        $this->DefaultPublication = $defaultPublication;
        return $this;
    }
    /**
     * Get InvalidPublicationMessage value
     * @return string
     */
    public function getInvalidPublicationMessage()
    {
        return $this->InvalidPublicationMessage;
    }
    /**
     * Set InvalidPublicationMessage value
     * @param string $invalidPublicationMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setInvalidPublicationMessage($invalidPublicationMessage = null)
    {
        // validation for constraint: string
        if (!is_null($invalidPublicationMessage) && !is_string($invalidPublicationMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($invalidPublicationMessage)), __LINE__);
        }
        $this->InvalidPublicationMessage = $invalidPublicationMessage;
        return $this;
    }
    /**
     * Get InvalidResponseMessage value
     * @return string
     */
    public function getInvalidResponseMessage()
    {
        return $this->InvalidResponseMessage;
    }
    /**
     * Set InvalidResponseMessage value
     * @param string $invalidResponseMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setInvalidResponseMessage($invalidResponseMessage = null)
    {
        // validation for constraint: string
        if (!is_null($invalidResponseMessage) && !is_string($invalidResponseMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($invalidResponseMessage)), __LINE__);
        }
        $this->InvalidResponseMessage = $invalidResponseMessage;
        return $this;
    }
    /**
     * Get MissingPublicationMessage value
     * @return string
     */
    public function getMissingPublicationMessage()
    {
        return $this->MissingPublicationMessage;
    }
    /**
     * Set MissingPublicationMessage value
     * @param string $missingPublicationMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setMissingPublicationMessage($missingPublicationMessage = null)
    {
        // validation for constraint: string
        if (!is_null($missingPublicationMessage) && !is_string($missingPublicationMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($missingPublicationMessage)), __LINE__);
        }
        $this->MissingPublicationMessage = $missingPublicationMessage;
        return $this;
    }
    /**
     * Get NeedPublicationMessage value
     * @return string
     */
    public function getNeedPublicationMessage()
    {
        return $this->NeedPublicationMessage;
    }
    /**
     * Set NeedPublicationMessage value
     * @param string $needPublicationMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setNeedPublicationMessage($needPublicationMessage = null)
    {
        // validation for constraint: string
        if (!is_null($needPublicationMessage) && !is_string($needPublicationMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($needPublicationMessage)), __LINE__);
        }
        $this->NeedPublicationMessage = $needPublicationMessage;
        return $this;
    }
    /**
     * Get PromptMessage value
     * @return string
     */
    public function getPromptMessage()
    {
        return $this->PromptMessage;
    }
    /**
     * Set PromptMessage value
     * @param string $promptMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setPromptMessage($promptMessage = null)
    {
        // validation for constraint: string
        if (!is_null($promptMessage) && !is_string($promptMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($promptMessage)), __LINE__);
        }
        $this->PromptMessage = $promptMessage;
        return $this;
    }
    /**
     * Get SuccessMessage value
     * @return string
     */
    public function getSuccessMessage()
    {
        return $this->SuccessMessage;
    }
    /**
     * Set SuccessMessage value
     * @param string $successMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setSuccessMessage($successMessage = null)
    {
        // validation for constraint: string
        if (!is_null($successMessage) && !is_string($successMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($successMessage)), __LINE__);
        }
        $this->SuccessMessage = $successMessage;
        return $this;
    }
    /**
     * Get UnexpectedErrorMessage value
     * @return string
     */
    public function getUnexpectedErrorMessage()
    {
        return $this->UnexpectedErrorMessage;
    }
    /**
     * Set UnexpectedErrorMessage value
     * @param string $unexpectedErrorMessage
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setUnexpectedErrorMessage($unexpectedErrorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($unexpectedErrorMessage) && !is_string($unexpectedErrorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($unexpectedErrorMessage)), __LINE__);
        }
        $this->UnexpectedErrorMessage = $unexpectedErrorMessage;
        return $this;
    }
    /**
     * Get ValidPublications value
     * @return \App\Library\ExactTarget\StructType\ValidPublications
     */
    public function getValidPublications()
    {
        return $this->ValidPublications;
    }
    /**
     * Set ValidPublications value
     * @param \App\Library\ExactTarget\StructType\ValidPublications $validPublications
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setValidPublications(\App\Library\ExactTarget\StructType\ValidPublications $validPublications = null)
    {
        $this->ValidPublications = $validPublications;
        return $this;
    }
    /**
     * Get ValidResponses value
     * @return \App\Library\ExactTarget\StructType\ValidResponses
     */
    public function getValidResponses()
    {
        return $this->ValidResponses;
    }
    /**
     * Set ValidResponses value
     * @param \App\Library\ExactTarget\StructType\ValidResponses $validResponses
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public function setValidResponses(\App\Library\ExactTarget\StructType\ValidResponses $validResponses = null)
    {
        $this->ValidResponses = $validResponses;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\DoubleOptInMOKeyword
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
