<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FileTriggerTypeLastPull StructType
 * @subpackage Structs
 */
class FileTriggerTypeLastPull extends APIObject
{
    /**
     * The ExternalReference
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ExternalReference;
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Type;
    /**
     * The LastPullDate
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LastPullDate;
    /**
     * Constructor method for FileTriggerTypeLastPull
     * @uses FileTriggerTypeLastPull::setExternalReference()
     * @uses FileTriggerTypeLastPull::setType()
     * @uses FileTriggerTypeLastPull::setLastPullDate()
     * @param string $externalReference
     * @param string $type
     * @param string $lastPullDate
     */
    public function __construct($externalReference = null, $type = null, $lastPullDate = null)
    {
        $this
            ->setExternalReference($externalReference)
            ->setType($type)
            ->setLastPullDate($lastPullDate);
    }
    /**
     * Get ExternalReference value
     * @return string|null
     */
    public function getExternalReference()
    {
        return $this->ExternalReference;
    }
    /**
     * Set ExternalReference value
     * @param string $externalReference
     * @return \App\Library\ExactTarget\StructType\FileTriggerTypeLastPull
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($externalReference)), __LINE__);
        }
        $this->ExternalReference = $externalReference;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \App\Library\ExactTarget\StructType\FileTriggerTypeLastPull
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get LastPullDate value
     * @return string|null
     */
    public function getLastPullDate()
    {
        return $this->LastPullDate;
    }
    /**
     * Set LastPullDate value
     * @param string $lastPullDate
     * @return \App\Library\ExactTarget\StructType\FileTriggerTypeLastPull
     */
    public function setLastPullDate($lastPullDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastPullDate) && !is_string($lastPullDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lastPullDate)), __LINE__);
        }
        $this->LastPullDate = $lastPullDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\FileTriggerTypeLastPull
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
