<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ForwardedEmailOptInEvent StructType
 * @subpackage Structs
 */
class ForwardedEmailOptInEvent extends TrackingEvent
{
    /**
     * The OptInSubscriberKey
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $OptInSubscriberKey;
    /**
     * Constructor method for ForwardedEmailOptInEvent
     * @uses ForwardedEmailOptInEvent::setOptInSubscriberKey()
     * @param string $optInSubscriberKey
     */
    public function __construct($optInSubscriberKey = null)
    {
        $this
            ->setOptInSubscriberKey($optInSubscriberKey);
    }
    /**
     * Get OptInSubscriberKey value
     * @return string|null
     */
    public function getOptInSubscriberKey()
    {
        return $this->OptInSubscriberKey;
    }
    /**
     * Set OptInSubscriberKey value
     * @param string $optInSubscriberKey
     * @return \App\Library\ExactTarget\StructType\ForwardedEmailOptInEvent
     */
    public function setOptInSubscriberKey($optInSubscriberKey = null)
    {
        // validation for constraint: string
        if (!is_null($optInSubscriberKey) && !is_string($optInSubscriberKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($optInSubscriberKey)), __LINE__);
        }
        $this->OptInSubscriberKey = $optInSubscriberKey;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ForwardedEmailOptInEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
