<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GlobalUnsubscribeCategory StructType
 * @subpackage Structs
 */
class GlobalUnsubscribeCategory extends APIObject
{
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The IgnorableByPartners
     * @var bool
     */
    public $IgnorableByPartners;
    /**
     * The Ignore
     * @var bool
     */
    public $Ignore;
    /**
     * Constructor method for GlobalUnsubscribeCategory
     * @uses GlobalUnsubscribeCategory::setName()
     * @uses GlobalUnsubscribeCategory::setIgnorableByPartners()
     * @uses GlobalUnsubscribeCategory::setIgnore()
     * @param string $name
     * @param bool $ignorableByPartners
     * @param bool $ignore
     */
    public function __construct($name = null, $ignorableByPartners = null, $ignore = null)
    {
        $this
            ->setName($name)
            ->setIgnorableByPartners($ignorableByPartners)
            ->setIgnore($ignore);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \App\Library\ExactTarget\StructType\GlobalUnsubscribeCategory
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get IgnorableByPartners value
     * @return bool|null
     */
    public function getIgnorableByPartners()
    {
        return $this->IgnorableByPartners;
    }
    /**
     * Set IgnorableByPartners value
     * @param bool $ignorableByPartners
     * @return \App\Library\ExactTarget\StructType\GlobalUnsubscribeCategory
     */
    public function setIgnorableByPartners($ignorableByPartners = null)
    {
        // validation for constraint: boolean
        if (!is_null($ignorableByPartners) && !is_bool($ignorableByPartners)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($ignorableByPartners)), __LINE__);
        }
        $this->IgnorableByPartners = $ignorableByPartners;
        return $this;
    }
    /**
     * Get Ignore value
     * @return bool|null
     */
    public function getIgnore()
    {
        return $this->Ignore;
    }
    /**
     * Set Ignore value
     * @param bool $ignore
     * @return \App\Library\ExactTarget\StructType\GlobalUnsubscribeCategory
     */
    public function setIgnore($ignore = null)
    {
        // validation for constraint: boolean
        if (!is_null($ignore) && !is_bool($ignore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($ignore)), __LINE__);
        }
        $this->Ignore = $ignore;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\GlobalUnsubscribeCategory
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
