<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ImportDefinitionAutoGenerateDestination StructType
 * @subpackage Structs
 */
class ImportDefinitionAutoGenerateDestination extends AbstractStructBase
{
    /**
     * The DataExtensionTarget
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\DataExtension
     */
    public $DataExtensionTarget;
    /**
     * The ErrorIfExists
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $ErrorIfExists;
    /**
     * Constructor method for ImportDefinitionAutoGenerateDestination
     * @uses ImportDefinitionAutoGenerateDestination::setDataExtensionTarget()
     * @uses ImportDefinitionAutoGenerateDestination::setErrorIfExists()
     * @param \App\Library\ExactTarget\StructType\DataExtension $dataExtensionTarget
     * @param bool $errorIfExists
     */
    public function __construct(\App\Library\ExactTarget\StructType\DataExtension $dataExtensionTarget = null, $errorIfExists = null)
    {
        $this
            ->setDataExtensionTarget($dataExtensionTarget)
            ->setErrorIfExists($errorIfExists);
    }
    /**
     * Get DataExtensionTarget value
     * @return \App\Library\ExactTarget\StructType\DataExtension
     */
    public function getDataExtensionTarget()
    {
        return $this->DataExtensionTarget;
    }
    /**
     * Set DataExtensionTarget value
     * @param \App\Library\ExactTarget\StructType\DataExtension $dataExtensionTarget
     * @return \App\Library\ExactTarget\StructType\ImportDefinitionAutoGenerateDestination
     */
    public function setDataExtensionTarget(\App\Library\ExactTarget\StructType\DataExtension $dataExtensionTarget = null)
    {
        $this->DataExtensionTarget = $dataExtensionTarget;
        return $this;
    }
    /**
     * Get ErrorIfExists value
     * @return bool|null
     */
    public function getErrorIfExists()
    {
        return $this->ErrorIfExists;
    }
    /**
     * Set ErrorIfExists value
     * @param bool $errorIfExists
     * @return \App\Library\ExactTarget\StructType\ImportDefinitionAutoGenerateDestination
     */
    public function setErrorIfExists($errorIfExists = null)
    {
        // validation for constraint: boolean
        if (!is_null($errorIfExists) && !is_bool($errorIfExists)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($errorIfExists)), __LINE__);
        }
        $this->ErrorIfExists = $errorIfExists;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ImportDefinitionAutoGenerateDestination
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
