<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for InteractionDefinition StructType
 * @subpackage Structs
 */
class InteractionDefinition extends InteractionBaseObject
{
    /**
     * The InteractionObjectID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $InteractionObjectID;
    /**
     * Constructor method for InteractionDefinition
     * @uses InteractionDefinition::setInteractionObjectID()
     * @param string $interactionObjectID
     */
    public function __construct($interactionObjectID = null)
    {
        $this
            ->setInteractionObjectID($interactionObjectID);
    }
    /**
     * Get InteractionObjectID value
     * @return string|null
     */
    public function getInteractionObjectID()
    {
        return $this->InteractionObjectID;
    }
    /**
     * Set InteractionObjectID value
     * @param string $interactionObjectID
     * @return \App\Library\ExactTarget\StructType\InteractionDefinition
     */
    public function setInteractionObjectID($interactionObjectID = null)
    {
        // validation for constraint: string
        if (!is_null($interactionObjectID) && !is_string($interactionObjectID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($interactionObjectID)), __LINE__);
        }
        $this->InteractionObjectID = $interactionObjectID;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\InteractionDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
