<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KeyErrors StructType
 * @subpackage Structs
 */
class KeyErrors extends AbstractStructBase
{
    /**
     * The KeyError
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\DataExtensionError[]
     */
    public $KeyError;
    /**
     * Constructor method for KeyErrors
     * @uses KeyErrors::setKeyError()
     * @param \App\Library\ExactTarget\StructType\DataExtensionError[] $keyError
     */
    public function __construct(array $keyError = array())
    {
        $this
            ->setKeyError($keyError);
    }
    /**
     * Get KeyError value
     * @return \App\Library\ExactTarget\StructType\DataExtensionError[]|null
     */
    public function getKeyError()
    {
        return $this->KeyError;
    }
    /**
     * Set KeyError value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\DataExtensionError[] $keyError
     * @return \App\Library\ExactTarget\StructType\KeyErrors
     */
    public function setKeyError(array $keyError = array())
    {
        foreach ($keyError as $keyErrorsKeyErrorItem) {
            // validation for constraint: itemType
            if (!$keyErrorsKeyErrorItem instanceof \App\Library\ExactTarget\StructType\DataExtensionError) {
                throw new \InvalidArgumentException(sprintf('The KeyError property can only contain items of \App\Library\ExactTarget\StructType\DataExtensionError, "%s" given', is_object($keyErrorsKeyErrorItem) ? get_class($keyErrorsKeyErrorItem) : gettype($keyErrorsKeyErrorItem)), __LINE__);
            }
        }
        $this->KeyError = $keyError;
        return $this;
    }
    /**
     * Add item to KeyError value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\DataExtensionError $item
     * @return \App\Library\ExactTarget\StructType\KeyErrors
     */
    public function addToKeyError(\App\Library\ExactTarget\StructType\DataExtensionError $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\DataExtensionError) {
            throw new \InvalidArgumentException(sprintf('The KeyError property can only contain items of \App\Library\ExactTarget\StructType\DataExtensionError, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->KeyError[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\KeyErrors
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
