<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MessagingVendorKind StructType
 * Meta informations extracted from the WSDL
 * - documentation: Deprecated.
 * @subpackage Structs
 */
class MessagingVendorKind extends APIObject
{
    /**
     * The Vendor
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Vendor;
    /**
     * The Kind
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Kind;
    /**
     * The IsUsernameRequired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsUsernameRequired;
    /**
     * The IsPasswordRequired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsPasswordRequired;
    /**
     * The IsProfileRequired
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsProfileRequired;
    /**
     * Constructor method for MessagingVendorKind
     * @uses MessagingVendorKind::setVendor()
     * @uses MessagingVendorKind::setKind()
     * @uses MessagingVendorKind::setIsUsernameRequired()
     * @uses MessagingVendorKind::setIsPasswordRequired()
     * @uses MessagingVendorKind::setIsProfileRequired()
     * @param string $vendor
     * @param string $kind
     * @param bool $isUsernameRequired
     * @param bool $isPasswordRequired
     * @param bool $isProfileRequired
     */
    public function __construct($vendor = null, $kind = null, $isUsernameRequired = null, $isPasswordRequired = null, $isProfileRequired = null)
    {
        $this
            ->setVendor($vendor)
            ->setKind($kind)
            ->setIsUsernameRequired($isUsernameRequired)
            ->setIsPasswordRequired($isPasswordRequired)
            ->setIsProfileRequired($isProfileRequired);
    }
    /**
     * Get Vendor value
     * @return string
     */
    public function getVendor()
    {
        return $this->Vendor;
    }
    /**
     * Set Vendor value
     * @param string $vendor
     * @return \App\Library\ExactTarget\StructType\MessagingVendorKind
     */
    public function setVendor($vendor = null)
    {
        // validation for constraint: string
        if (!is_null($vendor) && !is_string($vendor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($vendor)), __LINE__);
        }
        $this->Vendor = $vendor;
        return $this;
    }
    /**
     * Get Kind value
     * @return string
     */
    public function getKind()
    {
        return $this->Kind;
    }
    /**
     * Set Kind value
     * @param string $kind
     * @return \App\Library\ExactTarget\StructType\MessagingVendorKind
     */
    public function setKind($kind = null)
    {
        // validation for constraint: string
        if (!is_null($kind) && !is_string($kind)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($kind)), __LINE__);
        }
        $this->Kind = $kind;
        return $this;
    }
    /**
     * Get IsUsernameRequired value
     * @return bool
     */
    public function getIsUsernameRequired()
    {
        return $this->IsUsernameRequired;
    }
    /**
     * Set IsUsernameRequired value
     * @param bool $isUsernameRequired
     * @return \App\Library\ExactTarget\StructType\MessagingVendorKind
     */
    public function setIsUsernameRequired($isUsernameRequired = null)
    {
        // validation for constraint: boolean
        if (!is_null($isUsernameRequired) && !is_bool($isUsernameRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isUsernameRequired)), __LINE__);
        }
        $this->IsUsernameRequired = $isUsernameRequired;
        return $this;
    }
    /**
     * Get IsPasswordRequired value
     * @return bool
     */
    public function getIsPasswordRequired()
    {
        return $this->IsPasswordRequired;
    }
    /**
     * Set IsPasswordRequired value
     * @param bool $isPasswordRequired
     * @return \App\Library\ExactTarget\StructType\MessagingVendorKind
     */
    public function setIsPasswordRequired($isPasswordRequired = null)
    {
        // validation for constraint: boolean
        if (!is_null($isPasswordRequired) && !is_bool($isPasswordRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isPasswordRequired)), __LINE__);
        }
        $this->IsPasswordRequired = $isPasswordRequired;
        return $this;
    }
    /**
     * Get IsProfileRequired value
     * @return bool
     */
    public function getIsProfileRequired()
    {
        return $this->IsProfileRequired;
    }
    /**
     * Set IsProfileRequired value
     * @param bool $isProfileRequired
     * @return \App\Library\ExactTarget\StructType\MessagingVendorKind
     */
    public function setIsProfileRequired($isProfileRequired = null)
    {
        // validation for constraint: boolean
        if (!is_null($isProfileRequired) && !is_bool($isProfileRequired)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isProfileRequired)), __LINE__);
        }
        $this->IsProfileRequired = $isProfileRequired;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\MessagingVendorKind
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
