<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PerformRequest StructType
 * Meta informations extracted from the WSDL
 * - documentation: PerformRequest has been deprecated. See PerformRequestMsg.
 * @subpackage Structs
 */
class PerformRequest extends AbstractStructBase
{
    /**
     * The Client
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ClientID
     */
    public $Client;
    /**
     * The Action
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Action;
    /**
     * The Definitions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Definitions
     */
    public $Definitions;
    /**
     * Constructor method for PerformRequest
     * @uses PerformRequest::setClient()
     * @uses PerformRequest::setAction()
     * @uses PerformRequest::setDefinitions()
     * @param \App\Library\ExactTarget\StructType\ClientID $client
     * @param string $action
     * @param \App\Library\ExactTarget\StructType\Definitions $definitions
     */
    public function __construct(\App\Library\ExactTarget\StructType\ClientID $client = null, $action = null, \App\Library\ExactTarget\StructType\Definitions $definitions = null)
    {
        $this
            ->setClient($client)
            ->setAction($action)
            ->setDefinitions($definitions);
    }
    /**
     * Get Client value
     * @return \App\Library\ExactTarget\StructType\ClientID|null
     */
    public function getClient()
    {
        return $this->Client;
    }
    /**
     * Set Client value
     * @param \App\Library\ExactTarget\StructType\ClientID $client
     * @return \App\Library\ExactTarget\StructType\PerformRequest
     */
    public function setClient(\App\Library\ExactTarget\StructType\ClientID $client = null)
    {
        $this->Client = $client;
        return $this;
    }
    /**
     * Get Action value
     * @return string|null
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @param string $action
     * @return \App\Library\ExactTarget\StructType\PerformRequest
     */
    public function setAction($action = null)
    {
        // validation for constraint: string
        if (!is_null($action) && !is_string($action)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($action)), __LINE__);
        }
        $this->Action = $action;
        return $this;
    }
    /**
     * Get Definitions value
     * @return \App\Library\ExactTarget\StructType\Definitions|null
     */
    public function getDefinitions()
    {
        return $this->Definitions;
    }
    /**
     * Set Definitions value
     * @param \App\Library\ExactTarget\StructType\Definitions $definitions
     * @return \App\Library\ExactTarget\StructType\PerformRequest
     */
    public function setDefinitions(\App\Library\ExactTarget\StructType\Definitions $definitions = null)
    {
        $this->Definitions = $definitions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\PerformRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
