<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PrivateLabel StructType
 * @subpackage Structs
 */
class PrivateLabel extends AbstractStructBase
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $ID;
    /**
     * The Name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $Name;
    /**
     * The Delete
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Delete;
    /**
     * The ColorPaletteXML
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ColorPaletteXML;
    /**
     * The LogoFile
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LogoFile;
    /**
     * The SetActive
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $SetActive;
    /**
     * Constructor method for PrivateLabel
     * @uses PrivateLabel::setID()
     * @uses PrivateLabel::setName()
     * @uses PrivateLabel::setDelete()
     * @uses PrivateLabel::setColorPaletteXML()
     * @uses PrivateLabel::setLogoFile()
     * @uses PrivateLabel::setSetActive()
     * @param int $iD
     * @param string $name
     * @param int $delete
     * @param string $colorPaletteXML
     * @param string $logoFile
     * @param bool $setActive
     */
    public function __construct($iD = null, $name = null, $delete = null, $colorPaletteXML = null, $logoFile = null, $setActive = null)
    {
        $this
            ->setID($iD)
            ->setName($name)
            ->setDelete($delete)
            ->setColorPaletteXML($colorPaletteXML)
            ->setLogoFile($logoFile)
            ->setSetActive($setActive);
    }
    /**
     * Get ID value
     * @return int
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param int $iD
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public function setID($iD = null)
    {
        // validation for constraint: int
        if (!is_null($iD) && !is_numeric($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Name value
     * @return string
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Delete value
     * @return int
     */
    public function getDelete()
    {
        return $this->Delete;
    }
    /**
     * Set Delete value
     * @param int $delete
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public function setDelete($delete = null)
    {
        // validation for constraint: int
        if (!is_null($delete) && !is_numeric($delete)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($delete)), __LINE__);
        }
        $this->Delete = $delete;
        return $this;
    }
    /**
     * Get ColorPaletteXML value
     * @return string|null
     */
    public function getColorPaletteXML()
    {
        return $this->ColorPaletteXML;
    }
    /**
     * Set ColorPaletteXML value
     * @param string $colorPaletteXML
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public function setColorPaletteXML($colorPaletteXML = null)
    {
        // validation for constraint: string
        if (!is_null($colorPaletteXML) && !is_string($colorPaletteXML)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($colorPaletteXML)), __LINE__);
        }
        $this->ColorPaletteXML = $colorPaletteXML;
        return $this;
    }
    /**
     * Get LogoFile value
     * @return string|null
     */
    public function getLogoFile()
    {
        return $this->LogoFile;
    }
    /**
     * Set LogoFile value
     * @param string $logoFile
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public function setLogoFile($logoFile = null)
    {
        // validation for constraint: string
        if (!is_null($logoFile) && !is_string($logoFile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($logoFile)), __LINE__);
        }
        $this->LogoFile = $logoFile;
        return $this;
    }
    /**
     * Get SetActive value
     * @return bool|null
     */
    public function getSetActive()
    {
        return $this->SetActive;
    }
    /**
     * Set SetActive value
     * @param bool $setActive
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public function setSetActive($setActive = null)
    {
        // validation for constraint: boolean
        if (!is_null($setActive) && !is_bool($setActive)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($setActive)), __LINE__);
        }
        $this->SetActive = $setActive;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\PrivateLabel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
