<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Query StructType
 * @subpackage Structs
 */
class Query extends AbstractStructBase
{
    /**
     * The Object
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\QueryObject
     */
    public $Object;
    /**
     * The Filter
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\FilterPart
     */
    public $Filter;
    /**
     * Constructor method for Query
     * @uses Query::setObject()
     * @uses Query::setFilter()
     * @param \App\Library\ExactTarget\StructType\QueryObject $object
     * @param \App\Library\ExactTarget\StructType\FilterPart $filter
     */
    public function __construct(\App\Library\ExactTarget\StructType\QueryObject $object = null, \App\Library\ExactTarget\StructType\FilterPart $filter = null)
    {
        $this
            ->setObject($object)
            ->setFilter($filter);
    }
    /**
     * Get Object value
     * @return \App\Library\ExactTarget\StructType\QueryObject
     */
    public function getObject()
    {
        return $this->Object;
    }
    /**
     * Set Object value
     * @param \App\Library\ExactTarget\StructType\QueryObject $object
     * @return \App\Library\ExactTarget\StructType\Query
     */
    public function setObject(\App\Library\ExactTarget\StructType\QueryObject $object = null)
    {
        $this->Object = $object;
        return $this;
    }
    /**
     * Get Filter value
     * @return \App\Library\ExactTarget\StructType\FilterPart|null
     */
    public function getFilter()
    {
        return $this->Filter;
    }
    /**
     * Set Filter value
     * @param \App\Library\ExactTarget\StructType\FilterPart $filter
     * @return \App\Library\ExactTarget\StructType\Query
     */
    public function setFilter(\App\Library\ExactTarget\StructType\FilterPart $filter = null)
    {
        $this->Filter = $filter;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\Query
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
