<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SaveOptions StructType
 * @subpackage Structs
 */
class SaveOptions extends AbstractStructBase
{
    /**
     * The SaveOption
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\SaveOption[]
     */
    public $SaveOption;
    /**
     * Constructor method for SaveOptions
     * @uses SaveOptions::setSaveOption()
     * @param \App\Library\ExactTarget\StructType\SaveOption[] $saveOption
     */
    public function __construct(array $saveOption = array())
    {
        $this
            ->setSaveOption($saveOption);
    }
    /**
     * Get SaveOption value
     * @return \App\Library\ExactTarget\StructType\SaveOption[]|null
     */
    public function getSaveOption()
    {
        return $this->SaveOption;
    }
    /**
     * Set SaveOption value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\SaveOption[] $saveOption
     * @return \App\Library\ExactTarget\StructType\SaveOptions
     */
    public function setSaveOption(array $saveOption = array())
    {
        foreach ($saveOption as $saveOptionsSaveOptionItem) {
            // validation for constraint: itemType
            if (!$saveOptionsSaveOptionItem instanceof \App\Library\ExactTarget\StructType\SaveOption) {
                throw new \InvalidArgumentException(sprintf('The SaveOption property can only contain items of \App\Library\ExactTarget\StructType\SaveOption, "%s" given', is_object($saveOptionsSaveOptionItem) ? get_class($saveOptionsSaveOptionItem) : gettype($saveOptionsSaveOptionItem)), __LINE__);
            }
        }
        $this->SaveOption = $saveOption;
        return $this;
    }
    /**
     * Add item to SaveOption value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\SaveOption $item
     * @return \App\Library\ExactTarget\StructType\SaveOptions
     */
    public function addToSaveOption(\App\Library\ExactTarget\StructType\SaveOption $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\SaveOption) {
            throw new \InvalidArgumentException(sprintf('The SaveOption property can only contain items of \App\Library\ExactTarget\StructType\SaveOption, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SaveOption[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\SaveOptions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
