<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ScheduleRequestMsg StructType
 * @subpackage Structs
 */
class ScheduleRequestMsg extends AbstractStructBase
{
    /**
     * The Options
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ScheduleOptions
     */
    public $Options;
    /**
     * The Action
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Action;
    /**
     * The Schedule
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ScheduleDefinition
     */
    public $Schedule;
    /**
     * The Interactions
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Interactions
     */
    public $Interactions;
    /**
     * Constructor method for ScheduleRequestMsg
     * @uses ScheduleRequestMsg::setOptions()
     * @uses ScheduleRequestMsg::setAction()
     * @uses ScheduleRequestMsg::setSchedule()
     * @uses ScheduleRequestMsg::setInteractions()
     * @param \App\Library\ExactTarget\StructType\ScheduleOptions $options
     * @param string $action
     * @param \App\Library\ExactTarget\StructType\ScheduleDefinition $schedule
     * @param \App\Library\ExactTarget\StructType\Interactions $interactions
     */
    public function __construct(\App\Library\ExactTarget\StructType\ScheduleOptions $options = null, $action = null, \App\Library\ExactTarget\StructType\ScheduleDefinition $schedule = null, \App\Library\ExactTarget\StructType\Interactions $interactions = null)
    {
        $this
            ->setOptions($options)
            ->setAction($action)
            ->setSchedule($schedule)
            ->setInteractions($interactions);
    }
    /**
     * Get Options value
     * @return \App\Library\ExactTarget\StructType\ScheduleOptions|null
     */
    public function getOptions()
    {
        return $this->Options;
    }
    /**
     * Set Options value
     * @param \App\Library\ExactTarget\StructType\ScheduleOptions $options
     * @return \App\Library\ExactTarget\StructType\ScheduleRequestMsg
     */
    public function setOptions(\App\Library\ExactTarget\StructType\ScheduleOptions $options = null)
    {
        $this->Options = $options;
        return $this;
    }
    /**
     * Get Action value
     * @return string|null
     */
    public function getAction()
    {
        return $this->Action;
    }
    /**
     * Set Action value
     * @param string $action
     * @return \App\Library\ExactTarget\StructType\ScheduleRequestMsg
     */
    public function setAction($action = null)
    {
        // validation for constraint: string
        if (!is_null($action) && !is_string($action)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($action)), __LINE__);
        }
        $this->Action = $action;
        return $this;
    }
    /**
     * Get Schedule value
     * @return \App\Library\ExactTarget\StructType\ScheduleDefinition|null
     */
    public function getSchedule()
    {
        return $this->Schedule;
    }
    /**
     * Set Schedule value
     * @param \App\Library\ExactTarget\StructType\ScheduleDefinition $schedule
     * @return \App\Library\ExactTarget\StructType\ScheduleRequestMsg
     */
    public function setSchedule(\App\Library\ExactTarget\StructType\ScheduleDefinition $schedule = null)
    {
        $this->Schedule = $schedule;
        return $this;
    }
    /**
     * Get Interactions value
     * @return \App\Library\ExactTarget\StructType\Interactions|null
     */
    public function getInteractions()
    {
        return $this->Interactions;
    }
    /**
     * Set Interactions value
     * @param \App\Library\ExactTarget\StructType\Interactions $interactions
     * @return \App\Library\ExactTarget\StructType\ScheduleRequestMsg
     */
    public function setInteractions(\App\Library\ExactTarget\StructType\Interactions $interactions = null)
    {
        $this->Interactions = $interactions;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ScheduleRequestMsg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
