<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ScheduleResult StructType
 * @subpackage Structs
 */
class ScheduleResult extends Result
{
    /**
     * The Object
     * @var \App\Library\ExactTarget\StructType\ScheduleDefinition
     */
    public $Object;
    /**
     * The Task
     * @var \App\Library\ExactTarget\StructType\TaskResult
     */
    public $Task;
    /**
     * Constructor method for ScheduleResult
     * @uses ScheduleResult::setObject()
     * @uses ScheduleResult::setTask()
     * @param \App\Library\ExactTarget\StructType\ScheduleDefinition $object
     * @param \App\Library\ExactTarget\StructType\TaskResult $task
     */
    public function __construct(\App\Library\ExactTarget\StructType\ScheduleDefinition $object = null, \App\Library\ExactTarget\StructType\TaskResult $task = null)
    {
        $this
            ->setObject($object)
            ->setTask($task);
    }
    /**
     * Get Object value
     * @return \App\Library\ExactTarget\StructType\ScheduleDefinition|null
     */
    public function getObject()
    {
        return $this->Object;
    }
    /**
     * Set Object value
     * @param \App\Library\ExactTarget\StructType\ScheduleDefinition $object
     * @return \App\Library\ExactTarget\StructType\ScheduleResult
     */
    public function setObject(\App\Library\ExactTarget\StructType\ScheduleDefinition $object = null)
    {
        $this->Object = $object;
        return $this;
    }
    /**
     * Get Task value
     * @return \App\Library\ExactTarget\StructType\TaskResult|null
     */
    public function getTask()
    {
        return $this->Task;
    }
    /**
     * Set Task value
     * @param \App\Library\ExactTarget\StructType\TaskResult $task
     * @return \App\Library\ExactTarget\StructType\ScheduleResult
     */
    public function setTask(\App\Library\ExactTarget\StructType\TaskResult $task = null)
    {
        $this->Task = $task;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ScheduleResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
