<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SendSMSMOKeyword StructType
 * @subpackage Structs
 */
class SendSMSMOKeyword extends BaseMOKeyword
{
    /**
     * The NextMOKeyword
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\BaseMOKeyword
     */
    public $NextMOKeyword;
    /**
     * The Message
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * The ScriptErrorMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ScriptErrorMessage;
    /**
     * Constructor method for SendSMSMOKeyword
     * @uses SendSMSMOKeyword::setNextMOKeyword()
     * @uses SendSMSMOKeyword::setMessage()
     * @uses SendSMSMOKeyword::setScriptErrorMessage()
     * @param \App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword
     * @param string $message
     * @param string $scriptErrorMessage
     */
    public function __construct(\App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword = null, $message = null, $scriptErrorMessage = null)
    {
        $this
            ->setNextMOKeyword($nextMOKeyword)
            ->setMessage($message)
            ->setScriptErrorMessage($scriptErrorMessage);
    }
    /**
     * Get NextMOKeyword value
     * @return \App\Library\ExactTarget\StructType\BaseMOKeyword|null
     */
    public function getNextMOKeyword()
    {
        return $this->NextMOKeyword;
    }
    /**
     * Set NextMOKeyword value
     * @param \App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword
     * @return \App\Library\ExactTarget\StructType\SendSMSMOKeyword
     */
    public function setNextMOKeyword(\App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword = null)
    {
        $this->NextMOKeyword = $nextMOKeyword;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \App\Library\ExactTarget\StructType\SendSMSMOKeyword
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get ScriptErrorMessage value
     * @return string|null
     */
    public function getScriptErrorMessage()
    {
        return $this->ScriptErrorMessage;
    }
    /**
     * Set ScriptErrorMessage value
     * @param string $scriptErrorMessage
     * @return \App\Library\ExactTarget\StructType\SendSMSMOKeyword
     */
    public function setScriptErrorMessage($scriptErrorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($scriptErrorMessage) && !is_string($scriptErrorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($scriptErrorMessage)), __LINE__);
        }
        $this->ScriptErrorMessage = $scriptErrorMessage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\SendSMSMOKeyword
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
