<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SsoIdentities StructType
 * @subpackage Structs
 */
class SsoIdentities extends AbstractStructBase
{
    /**
     * The SsoIdentity
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\SsoIdentity[]
     */
    public $SsoIdentity;
    /**
     * Constructor method for SsoIdentities
     * @uses SsoIdentities::setSsoIdentity()
     * @param \App\Library\ExactTarget\StructType\SsoIdentity[] $ssoIdentity
     */
    public function __construct(array $ssoIdentity = array())
    {
        $this
            ->setSsoIdentity($ssoIdentity);
    }
    /**
     * Get SsoIdentity value
     * @return \App\Library\ExactTarget\StructType\SsoIdentity[]|null
     */
    public function getSsoIdentity()
    {
        return $this->SsoIdentity;
    }
    /**
     * Set SsoIdentity value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\SsoIdentity[] $ssoIdentity
     * @return \App\Library\ExactTarget\StructType\SsoIdentities
     */
    public function setSsoIdentity(array $ssoIdentity = array())
    {
        foreach ($ssoIdentity as $ssoIdentitiesSsoIdentityItem) {
            // validation for constraint: itemType
            if (!$ssoIdentitiesSsoIdentityItem instanceof \App\Library\ExactTarget\StructType\SsoIdentity) {
                throw new \InvalidArgumentException(sprintf('The SsoIdentity property can only contain items of \App\Library\ExactTarget\StructType\SsoIdentity, "%s" given', is_object($ssoIdentitiesSsoIdentityItem) ? get_class($ssoIdentitiesSsoIdentityItem) : gettype($ssoIdentitiesSsoIdentityItem)), __LINE__);
            }
        }
        $this->SsoIdentity = $ssoIdentity;
        return $this;
    }
    /**
     * Add item to SsoIdentity value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\SsoIdentity $item
     * @return \App\Library\ExactTarget\StructType\SsoIdentities
     */
    public function addToSsoIdentity(\App\Library\ExactTarget\StructType\SsoIdentity $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\SsoIdentity) {
            throw new \InvalidArgumentException(sprintf('The SsoIdentity property can only contain items of \App\Library\ExactTarget\StructType\SsoIdentity, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SsoIdentity[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\SsoIdentities
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
