<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Statuses StructType
 * @subpackage Structs
 */
class Statuses extends AbstractStructBase
{
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\AddressStatus[]
     */
    public $Status;
    /**
     * Constructor method for Statuses
     * @uses Statuses::setStatus()
     * @param \App\Library\ExactTarget\StructType\AddressStatus[] $status
     */
    public function __construct(array $status = array())
    {
        $this
            ->setStatus($status);
    }
    /**
     * Get Status value
     * @return \App\Library\ExactTarget\StructType\AddressStatus[]|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\AddressStatus[] $status
     * @return \App\Library\ExactTarget\StructType\Statuses
     */
    public function setStatus(array $status = array())
    {
        foreach ($status as $statusesStatusItem) {
            // validation for constraint: itemType
            if (!$statusesStatusItem instanceof \App\Library\ExactTarget\StructType\AddressStatus) {
                throw new \InvalidArgumentException(sprintf('The Status property can only contain items of \App\Library\ExactTarget\StructType\AddressStatus, "%s" given', is_object($statusesStatusItem) ? get_class($statusesStatusItem) : gettype($statusesStatusItem)), __LINE__);
            }
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Add item to Status value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\AddressStatus $item
     * @return \App\Library\ExactTarget\StructType\Statuses
     */
    public function addToStatus(\App\Library\ExactTarget\StructType\AddressStatus $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\AddressStatus) {
            throw new \InvalidArgumentException(sprintf('The Status property can only contain items of \App\Library\ExactTarget\StructType\AddressStatus, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Status[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\Statuses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
