<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TagFilterPart StructType
 * @subpackage Structs
 */
class TagFilterPart extends FilterPart
{
    /**
     * The Tags
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Tags
     */
    public $Tags;
    /**
     * Constructor method for TagFilterPart
     * @uses TagFilterPart::setTags()
     * @param \App\Library\ExactTarget\StructType\Tags $tags
     */
    public function __construct(\App\Library\ExactTarget\StructType\Tags $tags = null)
    {
        $this
            ->setTags($tags);
    }
    /**
     * Get Tags value
     * @return \App\Library\ExactTarget\StructType\Tags|null
     */
    public function getTags()
    {
        return $this->Tags;
    }
    /**
     * Set Tags value
     * @param \App\Library\ExactTarget\StructType\Tags $tags
     * @return \App\Library\ExactTarget\StructType\TagFilterPart
     */
    public function setTags(\App\Library\ExactTarget\StructType\Tags $tags = null)
    {
        $this->Tags = $tags;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\TagFilterPart
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
