<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TrackingUsers StructType
 * @subpackage Structs
 */
class TrackingUsers extends AbstractStructBase
{
    /**
     * The TrackingUser
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\TrackingUser[]
     */
    public $TrackingUser;
    /**
     * Constructor method for TrackingUsers
     * @uses TrackingUsers::setTrackingUser()
     * @param \App\Library\ExactTarget\StructType\TrackingUser[] $trackingUser
     */
    public function __construct(array $trackingUser = array())
    {
        $this
            ->setTrackingUser($trackingUser);
    }
    /**
     * Get TrackingUser value
     * @return \App\Library\ExactTarget\StructType\TrackingUser[]|null
     */
    public function getTrackingUser()
    {
        return $this->TrackingUser;
    }
    /**
     * Set TrackingUser value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\TrackingUser[] $trackingUser
     * @return \App\Library\ExactTarget\StructType\TrackingUsers
     */
    public function setTrackingUser(array $trackingUser = array())
    {
        foreach ($trackingUser as $trackingUsersTrackingUserItem) {
            // validation for constraint: itemType
            if (!$trackingUsersTrackingUserItem instanceof \App\Library\ExactTarget\StructType\TrackingUser) {
                throw new \InvalidArgumentException(sprintf('The TrackingUser property can only contain items of \App\Library\ExactTarget\StructType\TrackingUser, "%s" given', is_object($trackingUsersTrackingUserItem) ? get_class($trackingUsersTrackingUserItem) : gettype($trackingUsersTrackingUserItem)), __LINE__);
            }
        }
        $this->TrackingUser = $trackingUser;
        return $this;
    }
    /**
     * Add item to TrackingUser value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\TrackingUser $item
     * @return \App\Library\ExactTarget\StructType\TrackingUsers
     */
    public function addToTrackingUser(\App\Library\ExactTarget\StructType\TrackingUser $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\TrackingUser) {
            throw new \InvalidArgumentException(sprintf('The TrackingUser property can only contain items of \App\Library\ExactTarget\StructType\TrackingUser, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TrackingUser[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\TrackingUsers
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
