<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TriggeredSendCreateResult StructType
 * Meta informations extracted from the WSDL
 * - type: tns:TriggeredSendCreateResult
 * @subpackage Structs
 */
class TriggeredSendCreateResult extends CreateResult
{
    /**
     * The SubscriberFailures
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\SubscriberResult[]
     */
    public $SubscriberFailures;
    /**
     * Constructor method for TriggeredSendCreateResult
     * @uses TriggeredSendCreateResult::setSubscriberFailures()
     * @param \App\Library\ExactTarget\StructType\SubscriberResult[] $subscriberFailures
     */
    public function __construct(array $subscriberFailures = array())
    {
        $this
            ->setSubscriberFailures($subscriberFailures);
    }
    /**
     * Get SubscriberFailures value
     * @return \App\Library\ExactTarget\StructType\SubscriberResult[]|null
     */
    public function getSubscriberFailures()
    {
        return $this->SubscriberFailures;
    }
    /**
     * Set SubscriberFailures value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\SubscriberResult[] $subscriberFailures
     * @return \App\Library\ExactTarget\StructType\TriggeredSendCreateResult
     */
    public function setSubscriberFailures(array $subscriberFailures = array())
    {
        foreach ($subscriberFailures as $triggeredSendCreateResultSubscriberFailuresItem) {
            // validation for constraint: itemType
            if (!$triggeredSendCreateResultSubscriberFailuresItem instanceof \App\Library\ExactTarget\StructType\SubscriberResult) {
                throw new \InvalidArgumentException(sprintf('The SubscriberFailures property can only contain items of \App\Library\ExactTarget\StructType\SubscriberResult, "%s" given', is_object($triggeredSendCreateResultSubscriberFailuresItem) ? get_class($triggeredSendCreateResultSubscriberFailuresItem) : gettype($triggeredSendCreateResultSubscriberFailuresItem)), __LINE__);
            }
        }
        $this->SubscriberFailures = $subscriberFailures;
        return $this;
    }
    /**
     * Add item to SubscriberFailures value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\SubscriberResult $item
     * @return \App\Library\ExactTarget\StructType\TriggeredSendCreateResult
     */
    public function addToSubscriberFailures(\App\Library\ExactTarget\StructType\SubscriberResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\SubscriberResult) {
            throw new \InvalidArgumentException(sprintf('The SubscriberFailures property can only contain items of \App\Library\ExactTarget\StructType\SubscriberResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->SubscriberFailures[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\TriggeredSendCreateResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
