<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnsubEvent StructType
 * @subpackage Structs
 */
class UnsubEvent extends TrackingEvent
{
    /**
     * The List
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\_List
     */
    public $List;
    /**
     * The IsMasterUnsubscribed
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var bool
     */
    public $IsMasterUnsubscribed;
    /**
     * Constructor method for UnsubEvent
     * @uses UnsubEvent::setList()
     * @uses UnsubEvent::setIsMasterUnsubscribed()
     * @param \App\Library\ExactTarget\StructType\_List $list
     * @param bool $isMasterUnsubscribed
     */
    public function __construct(\App\Library\ExactTarget\StructType\_List $list = null, $isMasterUnsubscribed = null)
    {
        $this
            ->setList($list)
            ->setIsMasterUnsubscribed($isMasterUnsubscribed);
    }
    /**
     * Get List value
     * @return \App\Library\ExactTarget\StructType\_List|null
     */
    public function getList()
    {
        return $this->List;
    }
    /**
     * Set List value
     * @param \App\Library\ExactTarget\StructType\_List $list
     * @return \App\Library\ExactTarget\StructType\UnsubEvent
     */
    public function setList(\App\Library\ExactTarget\StructType\_List $list = null)
    {
        $this->List = $list;
        return $this;
    }
    /**
     * Get IsMasterUnsubscribed value
     * @return bool|null
     */
    public function getIsMasterUnsubscribed()
    {
        return $this->IsMasterUnsubscribed;
    }
    /**
     * Set IsMasterUnsubscribed value
     * @param bool $isMasterUnsubscribed
     * @return \App\Library\ExactTarget\StructType\UnsubEvent
     */
    public function setIsMasterUnsubscribed($isMasterUnsubscribed = null)
    {
        // validation for constraint: boolean
        if (!is_null($isMasterUnsubscribed) && !is_bool($isMasterUnsubscribed)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($isMasterUnsubscribed)), __LINE__);
        }
        $this->IsMasterUnsubscribed = $isMasterUnsubscribed;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\UnsubEvent
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
