<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UnsubscribeFromSMSPublicationMOKeyword StructType
 * @subpackage Structs
 */
class UnsubscribeFromSMSPublicationMOKeyword extends BaseMOKeyword
{
    /**
     * The AllUnsubSuccessMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $AllUnsubSuccessMessage;
    /**
     * The InvalidPublicationMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $InvalidPublicationMessage;
    /**
     * The SingleUnsubSuccessMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $SingleUnsubSuccessMessage;
    /**
     * The NextMOKeyword
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\BaseMOKeyword
     */
    public $NextMOKeyword;
    /**
     * Constructor method for UnsubscribeFromSMSPublicationMOKeyword
     * @uses UnsubscribeFromSMSPublicationMOKeyword::setAllUnsubSuccessMessage()
     * @uses UnsubscribeFromSMSPublicationMOKeyword::setInvalidPublicationMessage()
     * @uses UnsubscribeFromSMSPublicationMOKeyword::setSingleUnsubSuccessMessage()
     * @uses UnsubscribeFromSMSPublicationMOKeyword::setNextMOKeyword()
     * @param string $allUnsubSuccessMessage
     * @param string $invalidPublicationMessage
     * @param string $singleUnsubSuccessMessage
     * @param \App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword
     */
    public function __construct($allUnsubSuccessMessage = null, $invalidPublicationMessage = null, $singleUnsubSuccessMessage = null, \App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword = null)
    {
        $this
            ->setAllUnsubSuccessMessage($allUnsubSuccessMessage)
            ->setInvalidPublicationMessage($invalidPublicationMessage)
            ->setSingleUnsubSuccessMessage($singleUnsubSuccessMessage)
            ->setNextMOKeyword($nextMOKeyword);
    }
    /**
     * Get AllUnsubSuccessMessage value
     * @return string
     */
    public function getAllUnsubSuccessMessage()
    {
        return $this->AllUnsubSuccessMessage;
    }
    /**
     * Set AllUnsubSuccessMessage value
     * @param string $allUnsubSuccessMessage
     * @return \App\Library\ExactTarget\StructType\UnsubscribeFromSMSPublicationMOKeyword
     */
    public function setAllUnsubSuccessMessage($allUnsubSuccessMessage = null)
    {
        // validation for constraint: string
        if (!is_null($allUnsubSuccessMessage) && !is_string($allUnsubSuccessMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($allUnsubSuccessMessage)), __LINE__);
        }
        $this->AllUnsubSuccessMessage = $allUnsubSuccessMessage;
        return $this;
    }
    /**
     * Get InvalidPublicationMessage value
     * @return string
     */
    public function getInvalidPublicationMessage()
    {
        return $this->InvalidPublicationMessage;
    }
    /**
     * Set InvalidPublicationMessage value
     * @param string $invalidPublicationMessage
     * @return \App\Library\ExactTarget\StructType\UnsubscribeFromSMSPublicationMOKeyword
     */
    public function setInvalidPublicationMessage($invalidPublicationMessage = null)
    {
        // validation for constraint: string
        if (!is_null($invalidPublicationMessage) && !is_string($invalidPublicationMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($invalidPublicationMessage)), __LINE__);
        }
        $this->InvalidPublicationMessage = $invalidPublicationMessage;
        return $this;
    }
    /**
     * Get SingleUnsubSuccessMessage value
     * @return string
     */
    public function getSingleUnsubSuccessMessage()
    {
        return $this->SingleUnsubSuccessMessage;
    }
    /**
     * Set SingleUnsubSuccessMessage value
     * @param string $singleUnsubSuccessMessage
     * @return \App\Library\ExactTarget\StructType\UnsubscribeFromSMSPublicationMOKeyword
     */
    public function setSingleUnsubSuccessMessage($singleUnsubSuccessMessage = null)
    {
        // validation for constraint: string
        if (!is_null($singleUnsubSuccessMessage) && !is_string($singleUnsubSuccessMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($singleUnsubSuccessMessage)), __LINE__);
        }
        $this->SingleUnsubSuccessMessage = $singleUnsubSuccessMessage;
        return $this;
    }
    /**
     * Get NextMOKeyword value
     * @return \App\Library\ExactTarget\StructType\BaseMOKeyword|null
     */
    public function getNextMOKeyword()
    {
        return $this->NextMOKeyword;
    }
    /**
     * Set NextMOKeyword value
     * @param \App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword
     * @return \App\Library\ExactTarget\StructType\UnsubscribeFromSMSPublicationMOKeyword
     */
    public function setNextMOKeyword(\App\Library\ExactTarget\StructType\BaseMOKeyword $nextMOKeyword = null)
    {
        $this->NextMOKeyword = $nextMOKeyword;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\UnsubscribeFromSMSPublicationMOKeyword
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
