<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateRequest StructType
 * @subpackage Structs
 */
class UpdateRequest extends AbstractStructBase
{
    /**
     * The Options
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\UpdateOptions
     */
    public $Options;
    /**
     * The Objects
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\APIObject[]
     */
    public $Objects;
    /**
     * Constructor method for UpdateRequest
     * @uses UpdateRequest::setOptions()
     * @uses UpdateRequest::setObjects()
     * @param \App\Library\ExactTarget\StructType\UpdateOptions $options
     * @param \App\Library\ExactTarget\StructType\APIObject[] $objects
     */
    public function __construct(\App\Library\ExactTarget\StructType\UpdateOptions $options = null, array $objects = array())
    {
        $this
            ->setOptions($options)
            ->setObjects($objects);
    }
    /**
     * Get Options value
     * @return \App\Library\ExactTarget\StructType\UpdateOptions
     */
    public function getOptions()
    {
        return $this->Options;
    }
    /**
     * Set Options value
     * @param \App\Library\ExactTarget\StructType\UpdateOptions $options
     * @return \App\Library\ExactTarget\StructType\UpdateRequest
     */
    public function setOptions(\App\Library\ExactTarget\StructType\UpdateOptions $options = null)
    {
        $this->Options = $options;
        return $this;
    }
    /**
     * Get Objects value
     * @return \App\Library\ExactTarget\StructType\APIObject[]
     */
    public function getObjects()
    {
        return $this->Objects;
    }
    /**
     * Set Objects value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\APIObject[] $objects
     * @return \App\Library\ExactTarget\StructType\UpdateRequest
     */
    public function setObjects(array $objects = array())
    {
        foreach ($objects as $updateRequestObjectsItem) {
            // validation for constraint: itemType
            if (!$updateRequestObjectsItem instanceof \App\Library\ExactTarget\StructType\APIObject) {
                throw new \InvalidArgumentException(sprintf('The Objects property can only contain items of \App\Library\ExactTarget\StructType\APIObject, "%s" given', is_object($updateRequestObjectsItem) ? get_class($updateRequestObjectsItem) : gettype($updateRequestObjectsItem)), __LINE__);
            }
        }
        $this->Objects = $objects;
        return $this;
    }
    /**
     * Add item to Objects value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\APIObject $item
     * @return \App\Library\ExactTarget\StructType\UpdateRequest
     */
    public function addToObjects(\App\Library\ExactTarget\StructType\APIObject $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\APIObject) {
            throw new \InvalidArgumentException(sprintf('The Objects property can only contain items of \App\Library\ExactTarget\StructType\APIObject, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Objects[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\UpdateRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
