<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidPublications StructType
 * @subpackage Structs
 */
class ValidPublications extends AbstractStructBase
{
    /**
     * The ValidPublication
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var \App\Library\ExactTarget\StructType\_List[]
     */
    public $ValidPublication;
    /**
     * Constructor method for ValidPublications
     * @uses ValidPublications::setValidPublication()
     * @param \App\Library\ExactTarget\StructType\_List[] $validPublication
     */
    public function __construct(array $validPublication = array())
    {
        $this
            ->setValidPublication($validPublication);
    }
    /**
     * Get ValidPublication value
     * @return \App\Library\ExactTarget\StructType\_List[]
     */
    public function getValidPublication()
    {
        return $this->ValidPublication;
    }
    /**
     * Set ValidPublication value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\_List[] $validPublication
     * @return \App\Library\ExactTarget\StructType\ValidPublications
     */
    public function setValidPublication(array $validPublication = array())
    {
        foreach ($validPublication as $validPublicationsValidPublicationItem) {
            // validation for constraint: itemType
            if (!$validPublicationsValidPublicationItem instanceof \App\Library\ExactTarget\StructType\_List) {
                throw new \InvalidArgumentException(sprintf('The ValidPublication property can only contain items of \App\Library\ExactTarget\StructType\_List, "%s" given', is_object($validPublicationsValidPublicationItem) ? get_class($validPublicationsValidPublicationItem) : gettype($validPublicationsValidPublicationItem)), __LINE__);
            }
        }
        $this->ValidPublication = $validPublication;
        return $this;
    }
    /**
     * Add item to ValidPublication value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\_List $item
     * @return \App\Library\ExactTarget\StructType\ValidPublications
     */
    public function addToValidPublication(\App\Library\ExactTarget\StructType\_List $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\_List) {
            throw new \InvalidArgumentException(sprintf('The ValidPublication property can only contain items of \App\Library\ExactTarget\StructType\_List, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ValidPublication[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ValidPublications
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
