<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidResponses StructType
 * @subpackage Structs
 */
class ValidResponses extends AbstractStructBase
{
    /**
     * The ValidResponse
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 1
     * @var string[]
     */
    public $ValidResponse;
    /**
     * Constructor method for ValidResponses
     * @uses ValidResponses::setValidResponse()
     * @param string[] $validResponse
     */
    public function __construct(array $validResponse = array())
    {
        $this
            ->setValidResponse($validResponse);
    }
    /**
     * Get ValidResponse value
     * @return string[]
     */
    public function getValidResponse()
    {
        return $this->ValidResponse;
    }
    /**
     * Set ValidResponse value
     * @throws \InvalidArgumentException
     * @param string[] $validResponse
     * @return \App\Library\ExactTarget\StructType\ValidResponses
     */
    public function setValidResponse(array $validResponse = array())
    {
        foreach ($validResponse as $validResponsesValidResponseItem) {
            // validation for constraint: itemType
            if (!is_string($validResponsesValidResponseItem)) {
                throw new \InvalidArgumentException(sprintf('The ValidResponse property can only contain items of string, "%s" given', is_object($validResponsesValidResponseItem) ? get_class($validResponsesValidResponseItem) : gettype($validResponsesValidResponseItem)), __LINE__);
            }
        }
        $this->ValidResponse = $validResponse;
        return $this;
    }
    /**
     * Add item to ValidResponse value
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \App\Library\ExactTarget\StructType\ValidResponses
     */
    public function addToValidResponse($item)
    {
        // validation for constraint: itemType
        if (!is_string($item)) {
            throw new \InvalidArgumentException(sprintf('The ValidResponse property can only contain items of string, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ValidResponse[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ValidResponses
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
