<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ValidationResults StructType
 * @subpackage Structs
 */
class ValidationResults extends AbstractStructBase
{
    /**
     * The ValidationResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\ValidationResult[]
     */
    public $ValidationResult;
    /**
     * Constructor method for ValidationResults
     * @uses ValidationResults::setValidationResult()
     * @param \App\Library\ExactTarget\StructType\ValidationResult[] $validationResult
     */
    public function __construct(array $validationResult = array())
    {
        $this
            ->setValidationResult($validationResult);
    }
    /**
     * Get ValidationResult value
     * @return \App\Library\ExactTarget\StructType\ValidationResult[]|null
     */
    public function getValidationResult()
    {
        return $this->ValidationResult;
    }
    /**
     * Set ValidationResult value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\ValidationResult[] $validationResult
     * @return \App\Library\ExactTarget\StructType\ValidationResults
     */
    public function setValidationResult(array $validationResult = array())
    {
        foreach ($validationResult as $validationResultsValidationResultItem) {
            // validation for constraint: itemType
            if (!$validationResultsValidationResultItem instanceof \App\Library\ExactTarget\StructType\ValidationResult) {
                throw new \InvalidArgumentException(sprintf('The ValidationResult property can only contain items of \App\Library\ExactTarget\StructType\ValidationResult, "%s" given', is_object($validationResultsValidationResultItem) ? get_class($validationResultsValidationResultItem) : gettype($validationResultsValidationResultItem)), __LINE__);
            }
        }
        $this->ValidationResult = $validationResult;
        return $this;
    }
    /**
     * Add item to ValidationResult value
     * @throws \InvalidArgumentException
     * @param \App\Library\ExactTarget\StructType\ValidationResult $item
     * @return \App\Library\ExactTarget\StructType\ValidationResults
     */
    public function addToValidationResult(\App\Library\ExactTarget\StructType\ValidationResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \App\Library\ExactTarget\StructType\ValidationResult) {
            throw new \InvalidArgumentException(sprintf('The ValidationResult property can only contain items of \App\Library\ExactTarget\StructType\ValidationResult, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ValidationResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\ValidationResults
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
