<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VersionInfoRequestMsg StructType
 * @subpackage Structs
 */
class VersionInfoRequestMsg extends AbstractStructBase
{
    /**
     * The IncludeVersionHistory
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IncludeVersionHistory;
    /**
     * Constructor method for VersionInfoRequestMsg
     * @uses VersionInfoRequestMsg::setIncludeVersionHistory()
     * @param bool $includeVersionHistory
     */
    public function __construct($includeVersionHistory = null)
    {
        $this
            ->setIncludeVersionHistory($includeVersionHistory);
    }
    /**
     * Get IncludeVersionHistory value
     * @return bool
     */
    public function getIncludeVersionHistory()
    {
        return $this->IncludeVersionHistory;
    }
    /**
     * Set IncludeVersionHistory value
     * @param bool $includeVersionHistory
     * @return \App\Library\ExactTarget\StructType\VersionInfoRequestMsg
     */
    public function setIncludeVersionHistory($includeVersionHistory = null)
    {
        // validation for constraint: boolean
        if (!is_null($includeVersionHistory) && !is_bool($includeVersionHistory)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($includeVersionHistory)), __LINE__);
        }
        $this->IncludeVersionHistory = $includeVersionHistory;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\VersionInfoRequestMsg
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
