<?php

namespace App\Library\ExactTarget\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VoiceTriggeredSend StructType
 * @subpackage Structs
 */
class VoiceTriggeredSend extends APIObject
{
    /**
     * The VoiceTriggeredSendDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\VoiceTriggeredSendDefinition
     */
    public $VoiceTriggeredSendDefinition;
    /**
     * The Subscriber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \App\Library\ExactTarget\StructType\Subscriber
     */
    public $Subscriber;
    /**
     * The Message
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Message;
    /**
     * The Number
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Number;
    /**
     * The TransferMessage
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransferMessage;
    /**
     * The TransferNumber
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $TransferNumber;
    /**
     * Constructor method for VoiceTriggeredSend
     * @uses VoiceTriggeredSend::setVoiceTriggeredSendDefinition()
     * @uses VoiceTriggeredSend::setSubscriber()
     * @uses VoiceTriggeredSend::setMessage()
     * @uses VoiceTriggeredSend::setNumber()
     * @uses VoiceTriggeredSend::setTransferMessage()
     * @uses VoiceTriggeredSend::setTransferNumber()
     * @param \App\Library\ExactTarget\StructType\VoiceTriggeredSendDefinition $voiceTriggeredSendDefinition
     * @param \App\Library\ExactTarget\StructType\Subscriber $subscriber
     * @param string $message
     * @param string $number
     * @param string $transferMessage
     * @param string $transferNumber
     */
    public function __construct(\App\Library\ExactTarget\StructType\VoiceTriggeredSendDefinition $voiceTriggeredSendDefinition = null, \App\Library\ExactTarget\StructType\Subscriber $subscriber = null, $message = null, $number = null, $transferMessage = null, $transferNumber = null)
    {
        $this
            ->setVoiceTriggeredSendDefinition($voiceTriggeredSendDefinition)
            ->setSubscriber($subscriber)
            ->setMessage($message)
            ->setNumber($number)
            ->setTransferMessage($transferMessage)
            ->setTransferNumber($transferNumber);
    }
    /**
     * Get VoiceTriggeredSendDefinition value
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSendDefinition|null
     */
    public function getVoiceTriggeredSendDefinition()
    {
        return $this->VoiceTriggeredSendDefinition;
    }
    /**
     * Set VoiceTriggeredSendDefinition value
     * @param \App\Library\ExactTarget\StructType\VoiceTriggeredSendDefinition $voiceTriggeredSendDefinition
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public function setVoiceTriggeredSendDefinition(\App\Library\ExactTarget\StructType\VoiceTriggeredSendDefinition $voiceTriggeredSendDefinition = null)
    {
        $this->VoiceTriggeredSendDefinition = $voiceTriggeredSendDefinition;
        return $this;
    }
    /**
     * Get Subscriber value
     * @return \App\Library\ExactTarget\StructType\Subscriber|null
     */
    public function getSubscriber()
    {
        return $this->Subscriber;
    }
    /**
     * Set Subscriber value
     * @param \App\Library\ExactTarget\StructType\Subscriber $subscriber
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public function setSubscriber(\App\Library\ExactTarget\StructType\Subscriber $subscriber = null)
    {
        $this->Subscriber = $subscriber;
        return $this;
    }
    /**
     * Get Message value
     * @return string|null
     */
    public function getMessage()
    {
        return $this->Message;
    }
    /**
     * Set Message value
     * @param string $message
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public function setMessage($message = null)
    {
        // validation for constraint: string
        if (!is_null($message) && !is_string($message)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($message)), __LINE__);
        }
        $this->Message = $message;
        return $this;
    }
    /**
     * Get Number value
     * @return string|null
     */
    public function getNumber()
    {
        return $this->Number;
    }
    /**
     * Set Number value
     * @param string $number
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public function setNumber($number = null)
    {
        // validation for constraint: string
        if (!is_null($number) && !is_string($number)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($number)), __LINE__);
        }
        $this->Number = $number;
        return $this;
    }
    /**
     * Get TransferMessage value
     * @return string|null
     */
    public function getTransferMessage()
    {
        return $this->TransferMessage;
    }
    /**
     * Set TransferMessage value
     * @param string $transferMessage
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public function setTransferMessage($transferMessage = null)
    {
        // validation for constraint: string
        if (!is_null($transferMessage) && !is_string($transferMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($transferMessage)), __LINE__);
        }
        $this->TransferMessage = $transferMessage;
        return $this;
    }
    /**
     * Get TransferNumber value
     * @return string|null
     */
    public function getTransferNumber()
    {
        return $this->TransferNumber;
    }
    /**
     * Set TransferNumber value
     * @param string $transferNumber
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public function setTransferNumber($transferNumber = null)
    {
        // validation for constraint: string
        if (!is_null($transferNumber) && !is_string($transferNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($transferNumber)), __LINE__);
        }
        $this->TransferNumber = $transferNumber;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \App\Library\ExactTarget\StructType\VoiceTriggeredSend
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
